
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega64
;Program type           : Application
;Clock frequency        : 16,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega64
	#pragma AVRPART MEMORY PROG_FLASH 65536
	#pragma AVRPART MEMORY EEPROM 2048
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "1.vec"
	.INCLUDE "1.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V2.04.4a Advanced
;       4 Automatic Program Generator
;       5  Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 29.12.2010
;      11 Author  : sersne
;      12 Company : home
;      13 Comments:
;      14 
;      15 
;      16 Chip type               : ATmega64
;      17 Program type            : Application
;      18 AVR Core Clock frequency: 16,000000 MHz
;      19 Memory model            : Small
;      20 External RAM size       : 0
;      21 Data Stack size         : 1024
;      22 *****************************************************/
;      23 
;      24 #include <mega64.h>
;      25 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      26 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      27 	.EQU __se_bit=0x20
	.EQU __se_bit=0x20
;      28 	.EQU __sm_mask=0x1C
	.EQU __sm_mask=0x1C
;      29 	.EQU __sm_powerdown=0x10
	.EQU __sm_powerdown=0x10
;      30 	.EQU __sm_powersave=0x18
	.EQU __sm_powersave=0x18
;      31 	.EQU __sm_standby=0x14
	.EQU __sm_standby=0x14
;      32 	.EQU __sm_ext_standby=0x1C
	.EQU __sm_ext_standby=0x1C
;      33 	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_adc_noise_red=0x08
;      34 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      35 	#endif
	#endif
;      36 
;      37 #include <delay.h>
;      38 #include <stdlib.h>
;      39 #include <stdio.h>
;      40 
;      41 //  8x8      8x14
;      42 
;      43 #include "font8x8.h"

	.CSEG
;      44 #include <l020b_lcd.h>

	.DSEG

	.CSEG
_HardSPI_init:
	PUSH R15
	CBI  0x18,6
	SBI  0x17,6
	SBI  0x17,2
	CBI  0x17,4
	SBI  0x18,4
	SBI  0x17,3
	SBI  0x18,0
	SBI  0x17,0
	CBI  0x18,5
	SBI  0x17,5
	CBI  0x18,4
	SBI  0x18,5
	SBI  0x17,5
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	SBI  0x18,6
	LDI  R30,LOW(45)
	LDI  R31,HIGH(45)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	RET
_SPI_write:
	PUSH R15
;	SPI_Data_Byte -> Y+2
;	SPI_data_mode -> Y+1
;	CS_enable -> Y+0
	LD   R30,Y
	CPI  R30,0
	BRNE PC+3
	JMP _0x20
	SBI  0x18,0
_0x20:
	LDD  R30,Y+1
	CPI  R30,0
	BRNE PC+3
	JMP _0x23
	SBI  0x18,5
	RJMP _0x26
_0x23:
	CBI  0x18,5
_0x26:
	LD   R30,Y
	CPI  R30,0
	BRNE PC+3
	JMP _0x29
	CBI  0x18,0
_0x29:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _spi
	LD   R30,Y
	CPI  R30,0
	BRNE PC+3
	JMP _0x2C
	SBI  0x18,0
_0x2C:
	ADIW R28,3
	RET
_lcd_wrcmd16:
	PUSH R15
;	dat -> Y+0
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _SPI_write
	LD   R30,Y
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _SPI_write
	ADIW R28,2
	RET
_lcd_wrdat16:
	PUSH R15
;	dat -> Y+0
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _SPI_write
	LD   R30,Y
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _SPI_write
	ADIW R28,2
	RET
_lcd_clear:
	PUSH R15
	ST   -Y,R17
	ST   -Y,R16
;	_General_varcls -> R16,R17
	LDI  R16,128
	LDI  R17,181
	cli
	LDI  R30,LOW(61328)
	LDI  R31,HIGH(61328)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDI  R30,LOW(1280)
	LDI  R31,HIGH(1280)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDI  R30,LOW(1536)
	LDI  R31,HIGH(1536)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDI  R30,LOW(1792)
	LDI  R31,HIGH(1792)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
_0x2F:
	MOVW R30,R16
	__SUBWRN 16,17,1
	SBIW R30,0
	BRNE PC+3
	JMP _0x31
	LDI  R30,LOW(255)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _SPI_write
	RJMP _0x2F
_0x31:
	sei
	LD   R16,Y+
	LD   R17,Y+
	RET
_lcd_fill:
	PUSH R15
	ST   -Y,R17
	ST   -Y,R16
;	ls020_fill_color -> Y+2
;	_General_varfill -> R16,R17
	LDI  R16,192
	LDI  R17,90
	cli
	LDI  R30,LOW(61328)
	LDI  R31,HIGH(61328)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDI  R30,LOW(1280)
	LDI  R31,HIGH(1280)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDI  R30,LOW(2048)
	LDI  R31,HIGH(2048)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDI  R30,LOW(2435)
	LDI  R31,HIGH(2435)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDI  R30,LOW(2560)
	LDI  R31,HIGH(2560)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDI  R30,LOW(2991)
	LDI  R31,HIGH(2991)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
_0x32:
	MOVW R30,R16
	__SUBWRN 16,17,1
	SBIW R30,0
	BRNE PC+3
	JMP _0x34
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrdat16
	RJMP _0x32
_0x34:
	sei
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	RET
_lcd_gotoxy:
	PUSH R15
;	lcd_text_x -> Y+1
;	lcd_text_y -> Y+0
	LDD  R8,Y+1
	CLR  R9
	LDD  R10,Y+0
	CLR  R11
	ADIW R28,2
	RET
_lcd_reset_cursor:
	PUSH R15
	CLR  R10
	CLR  R11
	CLR  R8
	CLR  R9
	RET
_lcd_putpixel:
	PUSH R15
;	ls020x -> Y+2
;	ls020y -> Y+0
	cli
	LDI  R30,LOW(61328)
	LDI  R31,HIGH(61328)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDI  R30,LOW(1284)
	LDI  R31,HIGH(1284)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LD   R30,Y
	LDD  R31,Y+1
	SUBI R30,LOW(-2048)
	SBCI R31,HIGH(-2048)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LD   R30,Y
	LDD  R31,Y+1
	SUBI R30,LOW(-2304)
	SBCI R31,HIGH(-2304)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SUBI R30,LOW(-2560)
	SBCI R31,HIGH(-2560)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SUBI R30,LOW(-2816)
	SBCI R31,HIGH(-2816)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	ST   -Y,R7
	ST   -Y,R6
	CALL _lcd_wrdat16
	sei
	ADIW R28,4
	RET
_lcd_cputpixel:
	PUSH R15
;	ls020x -> Y+4
;	ls020y -> Y+2
;	ls020color -> Y+0
	cli
	LDI  R30,LOW(61328)
	LDI  R31,HIGH(61328)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDI  R30,LOW(1284)
	LDI  R31,HIGH(1284)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SUBI R30,LOW(-2048)
	SBCI R31,HIGH(-2048)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SUBI R30,LOW(-2304)
	SBCI R31,HIGH(-2304)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SUBI R30,LOW(-2560)
	SBCI R31,HIGH(-2560)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SUBI R30,LOW(-2816)
	SBCI R31,HIGH(-2816)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrdat16
	sei
	ADIW R28,6
	RET
_lcd_fillrect:
	PUSH R15
	CALL __SAVELOCR6
;	ls020x1 -> Y+14
;	ls020y1 -> Y+12
;	ls020x2 -> Y+10
;	ls020y2 -> Y+8
;	ls020color -> Y+6
;	ls020deltax -> R16,R17
;	ls020deltay -> R18,R19
;	_General_varfillrect -> R20,R21
	LDI  R16,0
	LDI  R17,0
	LDI  R18,0
	LDI  R19,0
	cli
	__GETWRN 20,21,0
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	CP   R30,R26
	CPC  R31,R27
	BRLO PC+3
	JMP _0x35
	__GETWRS 20,21,14
	STD  Y+14,R30
	STD  Y+14+1,R31
	__PUTWSR 20,21,10
_0x35:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CP   R30,R26
	CPC  R31,R27
	BRLO PC+3
	JMP _0x36
	__GETWRS 20,21,12
	STD  Y+12,R30
	STD  Y+12+1,R31
	__PUTWSR 20,21,8
_0x36:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	MOVW R16,R30
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	SUB  R30,R26
	SBC  R31,R27
	MOVW R18,R30
	MOVW R30,R18
	MOVW R26,R16
	CALL __MULW12U
	MOVW R20,R30
	LDI  R30,LOW(61328)
	LDI  R31,HIGH(61328)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDI  R30,LOW(1284)
	LDI  R31,HIGH(1284)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SUBI R30,LOW(-2048)
	SBCI R31,HIGH(-2048)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SUBI R30,LOW(-2304)
	SBCI R31,HIGH(-2304)
	ADD  R30,R16
	ADC  R31,R17
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SUBI R30,LOW(-2560)
	SBCI R31,HIGH(-2560)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SUBI R30,LOW(-2816)
	SBCI R31,HIGH(-2816)
	ADD  R30,R18
	ADC  R31,R19
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
_0x37:
	MOVW R30,R20
	__SUBWRN 20,21,1
	SBIW R30,0
	BRNE PC+3
	JMP _0x39
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrdat16
	RJMP _0x37
_0x39:
	sei
	CALL __LOADLOCR6
	ADIW R28,16
	RET
_lcd_color16:
	PUSH R15
;	ls020color24 -> Y+0
	__GETD2S 0
	LDI  R30,LOW(8)
	CALL __LSRD12
	__ANDD1N 0xF800
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(5)
	CALL __LSRW12
	__ANDD1N 0x7E0
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD21
	LD   R30,Y
	LSR  R30
	LSR  R30
	LSR  R30
	__ANDD1N 0x1F
	CALL __ADDD12
	ADIW R28,4
	RET
_LS020_lcd_init:
	PUSH R15
	ST   -Y,R17
	ST   -Y,R16
;	_General_varinit -> R16,R17
	cli
	SBI  0x18,0
	SBI  0x17,0
	CALL _HardSPI_init
	__GETWRN 16,17,0
_0x3F:
	__CPWRN 16,17,4
	BRLO PC+3
	JMP _0x40
	MOVW R30,R16
	SUBI R30,LOW(-_L020_INIT0*2)
	SBCI R31,HIGH(-_L020_INIT0*2)
	LPM  R30,Z
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _SPI_write
_0x3E:
	__ADDWRN 16,17,1
	RJMP _0x3F
_0x40:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	__GETWRN 16,17,0
_0x42:
	__CPWRN 16,17,20
	BRLO PC+3
	JMP _0x43
	MOVW R30,R16
	SUBI R30,LOW(-_L020_INIT1*2)
	SBCI R31,HIGH(-_L020_INIT1*2)
	LPM  R30,Z
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _SPI_write
_0x41:
	__ADDWRN 16,17,1
	RJMP _0x42
_0x43:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	__GETWRN 16,17,0
_0x45:
	__CPWRN 16,17,40
	BRLO PC+3
	JMP _0x46
	MOVW R30,R16
	SUBI R30,LOW(-_L020_INIT2*2)
	SBCI R31,HIGH(-_L020_INIT2*2)
	LPM  R30,Z
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _SPI_write
_0x44:
	__ADDWRN 16,17,1
	RJMP _0x45
_0x46:
	LDI  R30,LOW(49)
	LDI  R31,HIGH(49)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	__GETWRN 16,17,0
_0x48:
	__CPWRN 16,17,2
	BRLO PC+3
	JMP _0x49
	MOVW R30,R16
	SUBI R30,LOW(-_L020_INIT3*2)
	SBCI R31,HIGH(-_L020_INIT3*2)
	LPM  R30,Z
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _SPI_write
_0x47:
	__ADDWRN 16,17,1
	RJMP _0x48
_0x49:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(239)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _SPI_write
	LDI  R30,LOW(144)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _SPI_write
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _SPI_write
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _SPI_write
	CALL _lcd_clear
	LDI  R30,LOW(1)
	MOV  R13,R30
	sei
	LD   R16,Y+
	LD   R17,Y+
	RET
_lcd_d:
	PUSH R15
;	data -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrdat16
	ADIW R28,2
	RET
_lcd_c:
	PUSH R15
;	command -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_wrcmd16
	ADIW R28,2
	RET
_put_char:
	PUSH R15
	CALL __SAVELOCR6
;	x -> Y+10
;	y -> Y+9
;	c -> Y+8
;	color -> Y+6
;	h -> R17
;	ch -> R16
;	p -> R19
;	mask -> R18
;	tt -> R21
	LDD  R30,Y+10
	LDI  R31,0
	LDI  R26,LOW(148)
	LDI  R27,HIGH(148)
	CALL __SWAPW12
	SUB  R30,R26
	STD  Y+10,R30
	LDI  R30,LOW(61328)
	LDI  R31,HIGH(61328)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_c
	LDI  R30,LOW(1284)
	LDI  R31,HIGH(1284)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_c
	LDD  R30,Y+9
	LDI  R31,0
	SUBI R30,LOW(-2048)
	SBCI R31,HIGH(-2048)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_c
	LDD  R30,Y+10
	LDI  R31,0
	SUBI R30,LOW(-2560)
	SBCI R31,HIGH(-2560)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_c
	LDD  R30,Y+9
	LDI  R31,0
	SUBI R30,LOW(-2332)
	SBCI R31,HIGH(-2332)
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_c
	LDD  R30,Y+10
	LDI  R31,0
	SUBI R30,LOW(-2832)
	SBCI R31,HIGH(-2832)
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_c
	LDI  R17,LOW(28)
_0x4B:
	CPI  R17,1
	BRSH PC+3
	JMP _0x4C
	LDI  R21,LOW(0)
_0x4E:
	CPI  R21,1
	BRLO PC+3
	JMP _0x4F
	LDD  R30,Y+8
	LDI  R26,LOW(28)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_ascii_tab*2)
	SBCI R31,HIGH(-_ascii_tab*2)
	MOVW R22,R30
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	ADD  R30,R22
	ADC  R31,R23
	LPM  R16,Z
	LDI  R18,LOW(1)
	LDI  R19,LOW(0)
_0x51:
	CPI  R19,16
	BRLO PC+3
	JMP _0x52
	MOV  R30,R18
	LDI  R31,0
	MOV  R26,R16
	LDI  R27,0
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BRNE PC+3
	JMP _0x53
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_d
	RJMP _0x54
_0x53:
	ST   -Y,R5
	ST   -Y,R4
	CALL _lcd_d
_0x54:
	LSL  R18
_0x50:
	SUBI R19,-1
	RJMP _0x51
_0x52:
_0x4D:
	SUBI R21,-1
	RJMP _0x4E
_0x4F:
_0x4A:
	SUBI R17,1
	RJMP _0x4B
_0x4C:
	CALL __LOADLOCR6
	ADIW R28,11
	RET
_put_string:
	PUSH R15
	ST   -Y,R17
;	x -> Y+6
;	y -> Y+5
;	*str -> Y+3
;	color -> Y+1
;	j -> R17
	LDI  R17,0
_0x55:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R26,R17
	LDI  R27,0
	CP   R26,R30
	CPC  R27,R31
	BRLO PC+3
	JMP _0x57
	MOV  R30,R17
	SWAP R30
	ANDI R30,0xF0
	LDI  R31,0
	LDD  R26,Y+6
	LDI  R27,0
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R30
	LDD  R30,Y+6
	ST   -Y,R30
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
	SUBI R17,-1
	RJMP _0x55
_0x57:
	LDD  R17,Y+0
	ADIW R28,7
	RET
_ls020_power_OFF:
	PUSH R15
	CBI  0x18,6
	SBI  0x17,6
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	CBI  0x18,6
	CBI  0x17,6
	RET
;      45 
;      46 #include <io.h>
;      47 #include <math.h>
;      48 
;      49 
;      50 // 1 Wire Bus functions
;      51 #asm
;      52    .equ __w1_port=0x18
   .equ __w1_port=0x18
;      53    .equ __w1_bit=7
   .equ __w1_bit=7
;      54 #endasm
;      55 
;      56 #include <1wire.h>
;      57 
;      58 // DS1820 temperature sensor functions
;      59 #include <ds1820.h>
;      60 #include <delay.h>
;      61 // Declare your global variables here
;      62 
;      63 #define UP PINC.0
;      64 #define LEFT PINC.2
;      65 #define RIGHT PINC.1
;      66 #define DOWN PINC.4
;      67 #define MENU PINC.3
;      68 
;      69 // SPI functions
;      70 #include <spi.h>
;      71 
;      72 unsigned char sec;
;      73 
;      74 unsigned char show_data;

	.DSEG
_show_data:
	.BYTE 0x1
;      75 
;      76 int T,X1,X2,X3;
_T:
	.BYTE 0x2
_X1:
	.BYTE 0x2
_X2:
	.BYTE 0x2
_X3:
	.BYTE 0x2
;      77 
;      78 unsigned char focus;
_focus:
	.BYTE 0x1
;      79 
;      80 
;      81 //dat[0] - ten hours
;      82 //dat[1] - one hours
;      83 //dat[2] - ten minutes
;      84 //dat[3] - one minutes
;      85 //dat[4] - week
;      86 //dat[5] - ten day
;      87 //dat[6] - one day
;      88 //dat[7] - month
;      89 //dat[8] - ten year
;      90 //dat[9] - one year
;      91 unsigned char dat[10];
_dat:
	.BYTE 0xA
;      92 
;      93 
;      94 unsigned char time;
_time:
	.BYTE 0x1
;      95 unsigned char seconds;
_seconds:
	.BYTE 0x1
;      96 
;      97 //unsigned int fillcolor;
;      98 //char buffer[24];
;      99 //unsigned int i;
;     100 
;     101 unsigned char *month[12] =
_month:
;     102 {
;     103 " ",
;     104 "",
;     105 "   ",
;     106 " ",
;     107 "    ",
;     108 "   ",
;     109 "   ",
;     110 " ",
;     111 "",
;     112 "",
;     113 " ",
;     114 ""
;     115 };
	.BYTE 0x18
;     116 
;     117 
;     118 unsigned char *week[7] =
_week:
;     119 {
;     120 "",
;     121 "    ",
;     122 "      ",
;     123 "    ",
;     124 "    ",
;     125 "    ",
;     126 ""
;     127 };
	.BYTE 0xE
;     128 
;     129 unsigned char *menu[2] =
_menu:
;     130 {
;     131 "    ",
;     132 "MENU"
;     133 };
	.BYTE 0x4
;     134 
;     135 
;     136 // Declare your global variables here
;     137 
;     138 void set_month(char a, char b, char c, char d)
;     139 {

	.CSEG
_set_month:
	PUSH R15
;     140 
;     141         if ((a == c) && (b == d))
;	a -> Y+3
;	b -> Y+2
;	c -> Y+1
;	d -> Y+0
	LDD  R30,Y+1
	LDI  R31,0
	LDD  R26,Y+3
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BREQ PC+3
	JMP _0x67
	LD   R30,Y
	LDI  R31,0
	LDD  R26,Y+2
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BREQ PC+3
	JMP _0x67
	RJMP _0x68
_0x67:
	RJMP _0x66
_0x68:
;     142         {
;     143            dat[5] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,5
;     144            dat[6] = 1;
	LDI  R30,LOW(1)
	__PUTB1MN _dat,6
;     145 
;     146            dat[7] = dat[7] + 1; // 
	__GETB1MN _dat,7
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,7
;     147         }
;     148 }
_0x66:
	ADIW R28,4
	RET
;     149 
;     150 
;     151 void set_h_day(char a, char b, char c)
;     152 {
_set_h_day:
	PUSH R15
;     153 
;     154         if (dat[7] == a)  // 
;	a -> Y+2
;	b -> Y+1
;	c -> Y+0
	__GETB2MN _dat,7
	LDD  R30,Y+2
	LDI  R31,0
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BREQ PC+3
	JMP _0x69
;     155         {
;     156                 if ((++dat[5] > b)&&(dat[6] > c))
	__GETB1MN _dat,5
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,5
	MOV  R26,R30
	LDD  R30,Y+1
	CP   R30,R26
	BRLO PC+3
	JMP _0x6B
	__GETB2MN _dat,6
	LD   R30,Y
	CP   R30,R26
	BRLO PC+3
	JMP _0x6B
	RJMP _0x6C
_0x6B:
	RJMP _0x6A
_0x6C:
;     157                 {
;     158                         dat[5] = b;
	LDD  R30,Y+1
	__PUTB1MN _dat,5
;     159                         dat[6] = c;
	LD   R30,Y
	__PUTB1MN _dat,6
;     160                 }
;     161                 else
	RJMP _0x6D
_0x6A:
;     162                 {
;     163                         if (dat[5] > b) dat[5] = b;
	__GETB2MN _dat,5
	LDD  R30,Y+1
	CP   R30,R26
	BRLO PC+3
	JMP _0x6E
	__PUTB1MN _dat,5
;     164                 }
_0x6E:
_0x6D:
;     165         }
;     166 
;     167 
;     168 
;     169 }
_0x69:
	ADIW R28,3
	RET
;     170 
;     171 
;     172 void set_l_day(char a, char b, char c)
;     173 {
_set_l_day:
	PUSH R15
;     174 
;     175         if (dat[7] == a)  // 
;	a -> Y+2
;	b -> Y+1
;	c -> Y+0
	__GETB2MN _dat,7
	LDD  R30,Y+2
	LDI  R31,0
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BREQ PC+3
	JMP _0x6F
;     176         {
;     177                 dat[6] = dat[6] + 1;
	__GETB1MN _dat,6
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,6
;     178                 if ((dat[5] > b)&&(dat[6] > c))
	__GETB2MN _dat,5
	LDD  R30,Y+1
	CP   R30,R26
	BRLO PC+3
	JMP _0x71
	__GETB2MN _dat,6
	LD   R30,Y
	CP   R30,R26
	BRLO PC+3
	JMP _0x71
	RJMP _0x72
_0x71:
	RJMP _0x70
_0x72:
;     179                 {
;     180                         dat[5] = b;
	LDD  R30,Y+1
	__PUTB1MN _dat,5
;     181                         dat[6] = c;
	LD   R30,Y
	__PUTB1MN _dat,6
;     182                 }
;     183                 else
	RJMP _0x73
_0x70:
;     184                 {
;     185                         if ((dat[6] > 9)&&(dat[5] < b)) dat[6] = 9;
	__GETB2MN _dat,6
	CPI  R26,LOW(0xA)
	BRSH PC+3
	JMP _0x75
	__GETB2MN _dat,5
	LDD  R30,Y+1
	CP   R26,R30
	BRLO PC+3
	JMP _0x75
	RJMP _0x76
_0x75:
	RJMP _0x74
_0x76:
	LDI  R30,LOW(9)
	__PUTB1MN _dat,6
;     186                 }
_0x74:
_0x73:
;     187         }
;     188 
;     189 
;     190 
;     191 }
_0x6F:
	ADIW R28,3
	RET
;     192 
;     193 /*
;     194 ==============================================================================================
;     195            Timer 0
;     196 ==============================================================================================
;     197 */
;     198 
;     199 interrupt [TIM0_OVF] void timer0_ovf_isr (void)
;     200 {
_timer0_ovf_isr:
;     201 TCNT0=0x64;
	LDI  R30,LOW(100)
	OUT  0x32,R30
;     202 
;     203         if (++time == 150)
	LDS  R26,_time
	SUBI R26,-LOW(1)
	STS  _time,R26
	CPI  R26,LOW(0x96)
	BREQ PC+3
	JMP _0x77
;     204         {
;     205           time = 0;
	LDI  R30,LOW(0)
	STS  _time,R30
;     206 
;     207                 if (MENU == 0)
	SBIC 0x13,3
	RJMP _0x78
;     208                 {
;     209                         if (show_data == 0)
	LDS  R30,_show_data
	CPI  R30,0
	BREQ PC+3
	JMP _0x79
;     210                         {
;     211                                 show_data = 1;
	LDI  R30,LOW(1)
	STS  _show_data,R30
;     212                                 put_string(0,70,menu[0],BLACK);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(70)
	ST   -Y,R30
	LDS  R30,_menu
	LDS  R31,_menu+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     213                         }
;     214                         else
	RJMP _0x7A
_0x79:
;     215                         {
;     216                                 show_data = 0;
	LDI  R30,LOW(0)
	STS  _show_data,R30
;     217                                 put_string(0,70,menu[1],BLACK);
	ST   -Y,R30
	LDI  R30,LOW(70)
	ST   -Y,R30
	__GETW1MN _menu,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     218                         }
_0x7A:
;     219                 }
;     220 
;     221 
;     222 
;     223                 if (show_data == 0)
_0x78:
	LDS  R30,_show_data
	CPI  R30,0
	BREQ PC+3
	JMP _0x7B
;     224                 {
;     225 
;     226 
;     227 
;     228 
;     229                 //dat[0] - ten hours
;     230                 //dat[1] - one hours
;     231                 //dat[2] - ten minutes
;     232                 //dat[3] - one minutes
;     233                 //dat[4] - week
;     234                 //dat[5] - ten day
;     235                 //dat[6] - one day
;     236                 //dat[7] - month
;     237                 //dat[8] - ten year
;     238                 //dat[9] - one year
;     239 
;     240 
;     241 
;     242                         if (LEFT == 0)
	SBIC 0x13,2
	RJMP _0x7C
;     243                         {
;     244                                 focus = focus + 1;
	LDS  R30,_focus
	SUBI R30,-LOW(1)
	STS  _focus,R30
;     245                                 if (focus == 9) focus = 8;
	LDS  R26,_focus
	CPI  R26,LOW(0x9)
	BREQ PC+3
	JMP _0x7D
	LDI  R30,LOW(8)
	STS  _focus,R30
;     246                         }
_0x7D:
;     247 
;     248                         if (RIGHT == 0)
_0x7C:
	SBIC 0x13,1
	RJMP _0x7E
;     249                         {
;     250                                 focus = focus - 1;
	LDS  R30,_focus
	SUBI R30,LOW(1)
	STS  _focus,R30
;     251                                 if (focus == 0xFF) focus = 0;
	LDS  R26,_focus
	CPI  R26,LOW(0xFF)
	BREQ PC+3
	JMP _0x7F
	LDI  R30,LOW(0)
	STS  _focus,R30
;     252                         }
_0x7F:
;     253 
;     254                         if (UP == 0)
_0x7E:
	SBIC 0x13,0
	RJMP _0x80
;     255                         {
;     256                                 if (focus == 0) if (++dat[0] == 3) dat[0] = 2;
	LDS  R30,_focus
	CPI  R30,0
	BREQ PC+3
	JMP _0x81
	LDS  R26,_dat
	SUBI R26,-LOW(1)
	STS  _dat,R26
	CPI  R26,LOW(0x3)
	BREQ PC+3
	JMP _0x82
	LDI  R30,LOW(2)
	STS  _dat,R30
;     257 
;     258                                 if (focus == 1)
_0x82:
_0x81:
	LDS  R26,_focus
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x83
;     259                                 {
;     260                                         if (++dat[1] == 10) dat[1] = 9;
	__GETB1MN _dat,1
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,1
	CPI  R30,LOW(0xA)
	BREQ PC+3
	JMP _0x84
	LDI  R30,LOW(9)
	__PUTB1MN _dat,1
;     261 
;     262                                         if (dat[0] >= 2)
_0x84:
	LDS  R26,_dat
	CPI  R26,LOW(0x2)
	BRSH PC+3
	JMP _0x85
;     263                                         {
;     264                                              if (dat[1] > 3) dat[1] = 3;
	__GETB2MN _dat,1
	CPI  R26,LOW(0x4)
	BRSH PC+3
	JMP _0x86
	LDI  R30,LOW(3)
	__PUTB1MN _dat,1
;     265                                         }
_0x86:
;     266                                 }
_0x85:
;     267 
;     268 
;     269                                 if (focus == 2) if (++dat[2] >= 6) dat[2] = 5;
_0x83:
	LDS  R26,_focus
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x87
	__GETB1MN _dat,2
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,2
	CPI  R30,LOW(0x6)
	BRSH PC+3
	JMP _0x88
	LDI  R30,LOW(5)
	__PUTB1MN _dat,2
;     270 
;     271                                 if (focus == 3) if (++dat[3] == 10) dat[3] = 9;
_0x88:
_0x87:
	LDS  R26,_focus
	CPI  R26,LOW(0x3)
	BREQ PC+3
	JMP _0x89
	__GETB1MN _dat,3
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,3
	CPI  R30,LOW(0xA)
	BREQ PC+3
	JMP _0x8A
	LDI  R30,LOW(9)
	__PUTB1MN _dat,3
;     272 
;     273 
;     274                                 if (focus == 4) if (++dat[4] >= 8) dat[4] = 7;
_0x8A:
_0x89:
	LDS  R26,_focus
	CPI  R26,LOW(0x4)
	BREQ PC+3
	JMP _0x8B
	__GETB1MN _dat,4
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,4
	CPI  R30,LOW(0x8)
	BRSH PC+3
	JMP _0x8C
	LDI  R30,LOW(7)
	__PUTB1MN _dat,4
;     275 
;     276 
;     277                                 if (focus == 5) if (++dat[7] >= 12) dat[7] = 11;
_0x8C:
_0x8B:
	LDS  R26,_focus
	CPI  R26,LOW(0x5)
	BREQ PC+3
	JMP _0x8D
	__GETB1MN _dat,7
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,7
	CPI  R30,LOW(0xC)
	BRSH PC+3
	JMP _0x8E
	LDI  R30,LOW(11)
	__PUTB1MN _dat,7
;     278 
;     279                                 if (focus == 6)
_0x8E:
_0x8D:
	LDS  R26,_focus
	CPI  R26,LOW(0x6)
	BREQ PC+3
	JMP _0x8F
;     280                                 {
;     281 
;     282                                         set_h_day(0,3,1);  //  
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_h_day
;     283                                         set_h_day(1,2,8);  //  
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _set_h_day
;     284                                         set_h_day(2,3,1);  //  
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_h_day
;     285                                         set_h_day(3,3,0);  //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _set_h_day
;     286                                         set_h_day(4,3,1);  //  
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_h_day
;     287                                         set_h_day(5,3,0);  //  
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _set_h_day
;     288                                         set_h_day(6,3,1);  //  
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_h_day
;     289                                         set_h_day(7,3,1);  //  
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_h_day
;     290                                         set_h_day(8,3,0);  //  
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _set_h_day
;     291                                         set_h_day(9,3,1);  //  
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_h_day
;     292                                         set_h_day(10,3,0);  //  
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _set_h_day
;     293                                         set_h_day(11,3,1);  //  
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_h_day
;     294 
;     295                                 }
;     296 
;     297 
;     298                                 if (focus == 7)
_0x8F:
	LDS  R26,_focus
	CPI  R26,LOW(0x7)
	BREQ PC+3
	JMP _0x90
;     299                                 {
;     300 
;     301                                         set_l_day(0,3,1);  //  
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_l_day
;     302                                         set_l_day(1,2,8);  //  
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _set_l_day
;     303                                         set_l_day(2,3,1);  //  
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_l_day
;     304                                         set_l_day(3,3,0);  //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _set_l_day
;     305                                         set_l_day(4,3,1);  //  
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_l_day
;     306                                         set_l_day(5,3,0);  //  
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _set_l_day
;     307                                         set_l_day(6,3,1);  //  
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_l_day
;     308                                         set_l_day(7,3,1);  //  
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_l_day
;     309                                         set_l_day(8,3,0);  //  
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _set_l_day
;     310                                         set_l_day(9,3,1);  //  
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_l_day
;     311                                         set_l_day(10,3,0);  //  
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _set_l_day
;     312                                         set_l_day(11,3,1);  //  
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _set_l_day
;     313 
;     314                                 }
;     315 
;     316 
;     317                                 if (focus == 8)
_0x90:
	LDS  R26,_focus
	CPI  R26,LOW(0x8)
	BREQ PC+3
	JMP _0x91
;     318                                 {
;     319                                         if (++dat[9] > 9)
	__GETB1MN _dat,9
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,9
	CPI  R30,LOW(0xA)
	BRSH PC+3
	JMP _0x92
;     320                                         {
;     321                                                 dat[9] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,9
;     322 
;     323                                                 if (++dat[8] > 2) dat[8] = 2;
	__GETB1MN _dat,8
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,8
	CPI  R30,LOW(0x3)
	BRSH PC+3
	JMP _0x93
	LDI  R30,LOW(2)
	__PUTB1MN _dat,8
;     324 
;     325 
;     326                                         }
_0x93:
;     327                                 }
_0x92:
;     328                         }
_0x91:
;     329 
;     330 
;     331 
;     332 
;     333 
;     334 
;     335                         if (DOWN == 0)
_0x80:
	SBIC 0x13,4
	RJMP _0x94
;     336                         {
;     337                                 if (focus == 0) if (--dat[0] == 0xFF) dat[0] = 0;
	LDS  R30,_focus
	CPI  R30,0
	BREQ PC+3
	JMP _0x95
	LDS  R26,_dat
	SUBI R26,LOW(1)
	STS  _dat,R26
	CPI  R26,LOW(0xFF)
	BREQ PC+3
	JMP _0x96
	LDI  R30,LOW(0)
	STS  _dat,R30
;     338 
;     339                                 if (focus == 1) if (--dat[1] == 0xFF) dat[1] = 0;
_0x96:
_0x95:
	LDS  R26,_focus
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x97
	__GETB1MN _dat,1
	SUBI R30,LOW(1)
	__PUTB1MN _dat,1
	CPI  R30,LOW(0xFF)
	BREQ PC+3
	JMP _0x98
	LDI  R30,LOW(0)
	__PUTB1MN _dat,1
;     340 
;     341                                 if (focus == 2) if (--dat[2] == 0xFF) dat[2] = 0;
_0x98:
_0x97:
	LDS  R26,_focus
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x99
	__GETB1MN _dat,2
	SUBI R30,LOW(1)
	__PUTB1MN _dat,2
	CPI  R30,LOW(0xFF)
	BREQ PC+3
	JMP _0x9A
	LDI  R30,LOW(0)
	__PUTB1MN _dat,2
;     342 
;     343                                 if (focus == 3) if (--dat[3] == 0xFF) dat[3] = 0;
_0x9A:
_0x99:
	LDS  R26,_focus
	CPI  R26,LOW(0x3)
	BREQ PC+3
	JMP _0x9B
	__GETB1MN _dat,3
	SUBI R30,LOW(1)
	__PUTB1MN _dat,3
	CPI  R30,LOW(0xFF)
	BREQ PC+3
	JMP _0x9C
	LDI  R30,LOW(0)
	__PUTB1MN _dat,3
;     344 
;     345                                 if (focus == 4) if (--dat[4] == 0xFF) dat[4] = 0;
_0x9C:
_0x9B:
	LDS  R26,_focus
	CPI  R26,LOW(0x4)
	BREQ PC+3
	JMP _0x9D
	__GETB1MN _dat,4
	SUBI R30,LOW(1)
	__PUTB1MN _dat,4
	CPI  R30,LOW(0xFF)
	BREQ PC+3
	JMP _0x9E
	LDI  R30,LOW(0)
	__PUTB1MN _dat,4
;     346 
;     347                                 if (focus == 5) if (--dat[7] == 0xFF) dat[7] = 0;
_0x9E:
_0x9D:
	LDS  R26,_focus
	CPI  R26,LOW(0x5)
	BREQ PC+3
	JMP _0x9F
	__GETB1MN _dat,7
	SUBI R30,LOW(1)
	__PUTB1MN _dat,7
	CPI  R30,LOW(0xFF)
	BREQ PC+3
	JMP _0xA0
	LDI  R30,LOW(0)
	__PUTB1MN _dat,7
;     348 
;     349                                 if (focus == 6) if (--dat[5] == 0xFF) dat[5] = 0;
_0xA0:
_0x9F:
	LDS  R26,_focus
	CPI  R26,LOW(0x6)
	BREQ PC+3
	JMP _0xA1
	__GETB1MN _dat,5
	SUBI R30,LOW(1)
	__PUTB1MN _dat,5
	CPI  R30,LOW(0xFF)
	BREQ PC+3
	JMP _0xA2
	LDI  R30,LOW(0)
	__PUTB1MN _dat,5
;     350 
;     351                                 if (focus == 7) if (--dat[6] == 0xFF) dat[6] = 0;
_0xA2:
_0xA1:
	LDS  R26,_focus
	CPI  R26,LOW(0x7)
	BREQ PC+3
	JMP _0xA3
	__GETB1MN _dat,6
	SUBI R30,LOW(1)
	__PUTB1MN _dat,6
	CPI  R30,LOW(0xFF)
	BREQ PC+3
	JMP _0xA4
	LDI  R30,LOW(0)
	__PUTB1MN _dat,6
;     352 
;     353                                 if (focus == 8)
_0xA4:
_0xA3:
	LDS  R26,_focus
	CPI  R26,LOW(0x8)
	BREQ PC+3
	JMP _0xA5
;     354                                 {
;     355                                         if (--dat[9] == 0xFF)
	__GETB1MN _dat,9
	SUBI R30,LOW(1)
	__PUTB1MN _dat,9
	CPI  R30,LOW(0xFF)
	BREQ PC+3
	JMP _0xA6
;     356                                         {
;     357                                                 dat[9] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,9
;     358 
;     359                                                 if (--dat[8] == 0xFF) dat[8] = 0;
	__GETB1MN _dat,8
	SUBI R30,LOW(1)
	__PUTB1MN _dat,8
	CPI  R30,LOW(0xFF)
	BREQ PC+3
	JMP _0xA7
	LDI  R30,LOW(0)
	__PUTB1MN _dat,8
;     360                                         }
_0xA7:
;     361                                 }
_0xA6:
;     362                         }
_0xA5:
;     363 
;     364                         if (focus == 0)
_0x94:
	LDS  R30,_focus
	CPI  R30,0
	BREQ PC+3
	JMP _0xA8
;     365                         {
;     366                                 put_char(0,1,dat[0] + 48, RED);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDS  R30,_dat
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     367                         }
;     368                         else
	RJMP _0xA9
_0xA8:
;     369                         {
;     370                                 put_char(0,1,dat[0] + 48,BLACK);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDS  R30,_dat
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     371                         }
_0xA9:
;     372 
;     373                         if (focus == 1)
	LDS  R26,_focus
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xAA
;     374                         {
;     375 
;     376                                 put_char(9,1,dat[1] + 48,RED);
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,1
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     377                         }
;     378                         else
	RJMP _0xAB
_0xAA:
;     379                         {
;     380                                 put_char(9,1,dat[1] + 48,BLACK);
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,1
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     381                         }
_0xAB:
;     382 
;     383 
;     384                                 put_string(18,1,":",BLACK);
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__POINTW1FN _0,185
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     385 
;     386                         if (focus == 2)
	LDS  R26,_focus
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0xAC
;     387                         {
;     388                                 put_char(27,1,dat[2] + 48,RED);
	LDI  R30,LOW(27)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,2
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     389                         }
;     390                         else
	RJMP _0xAD
_0xAC:
;     391                         {
;     392                                 put_char(27,1,dat[2] + 48,BLACK);
	LDI  R30,LOW(27)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,2
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     393                         }
_0xAD:
;     394 
;     395                         if (focus == 3)
	LDS  R26,_focus
	CPI  R26,LOW(0x3)
	BREQ PC+3
	JMP _0xAE
;     396                         {
;     397                                 put_char(36,1,dat[3] + 48,RED);
	LDI  R30,LOW(36)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,3
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     398                         }
;     399                         else
	RJMP _0xAF
_0xAE:
;     400                         {
;     401                                 put_char(36,1,dat[3] + 48,BLACK);
	LDI  R30,LOW(36)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,3
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     402                         }
_0xAF:
;     403 
;     404                         if (focus == 4)
	LDS  R26,_focus
	CPI  R26,LOW(0x4)
	BREQ PC+3
	JMP _0xB0
;     405                         {
;     406                                 put_string(56,1,week[dat[4]],RED);
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,4
	LDI  R31,0
	LDI  R26,LOW(_week)
	LDI  R27,HIGH(_week)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     407                         }
;     408                         else
	RJMP _0xB1
_0xB0:
;     409                         {
;     410                                 put_string(56,1,week[dat[4]],BLACK);
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,4
	LDI  R31,0
	LDI  R26,LOW(_week)
	LDI  R27,HIGH(_week)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     411                         }
_0xB1:
;     412 
;     413                         if (focus == 6)
	LDS  R26,_focus
	CPI  R26,LOW(0x6)
	BREQ PC+3
	JMP _0xB2
;     414                         {
;     415                                 put_char(0,20,dat[5] + 48,RED);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,5
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     416                         }
;     417                         else
	RJMP _0xB3
_0xB2:
;     418                         {
;     419                                 put_char(0,20,dat[5] + 48,BLACK);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,5
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     420                         }
_0xB3:
;     421 
;     422                         if (focus == 7)
	LDS  R26,_focus
	CPI  R26,LOW(0x7)
	BREQ PC+3
	JMP _0xB4
;     423                         {
;     424                                 put_char(9,20,dat[6] + 48,RED);
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,6
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     425                         }
;     426                         else
	RJMP _0xB5
_0xB4:
;     427                         {
;     428                                 put_char(9,20,dat[6] + 48,BLACK);
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,6
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     429                         }
_0xB5:
;     430 
;     431 
;     432                         if (focus == 5)
	LDS  R26,_focus
	CPI  R26,LOW(0x5)
	BREQ PC+3
	JMP _0xB6
;     433                         {
;     434                                 put_string(22,20,month[dat[7]],RED);
	LDI  R30,LOW(22)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,7
	LDI  R31,0
	LDI  R26,LOW(_month)
	LDI  R27,HIGH(_month)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     435                         }
;     436                         else
	RJMP _0xB7
_0xB6:
;     437                         {
;     438                                 put_string(22,20,month[dat[7]],BLACK);
	LDI  R30,LOW(22)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,7
	LDI  R31,0
	LDI  R26,LOW(_month)
	LDI  R27,HIGH(_month)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     439                         }
_0xB7:
;     440 
;     441 
;     442                         if (focus == 8)
	LDS  R26,_focus
	CPI  R26,LOW(0x8)
	BREQ PC+3
	JMP _0xB8
;     443                         {
;     444                                 put_char(82,20,50,RED);
	LDI  R30,LOW(82)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     445                                 put_char(91,20,48,RED);
	LDI  R30,LOW(91)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     446                                 put_char(100,20,dat[8] + 48,RED);
	LDI  R30,LOW(100)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,8
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     447                                 put_char(109,20,dat[9] + 48,RED);                        }
	LDI  R30,LOW(109)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,9
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     448                         else
	RJMP _0xB9
_0xB8:
;     449                         {
;     450                                 put_char(82,20,50,BLACK);
	LDI  R30,LOW(82)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     451                                 put_char(91,20,48,BLACK);
	LDI  R30,LOW(91)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     452                                 put_char(100,20,dat[8] + 48,BLACK);
	LDI  R30,LOW(100)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,8
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     453                                 put_char(109,20,dat[9] + 48,BLACK);
	LDI  R30,LOW(109)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,9
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     454                         }
_0xB9:
;     455                 }
;     456         }
_0x7B:
;     457 }
_0x77:
	RETI
;     458 
;     459 
;     460 
;     461 
;     462 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;     463 {
_timer1_ovf_isr:
;     464 
;     465 
;     466         TCNT1H=0xC2;
	LDI  R30,LOW(194)
	OUT  0x2D,R30
;     467         TCNT1L=0xF7;
	LDI  R30,LOW(247)
	OUT  0x2C,R30
;     468 
;     469 
;     470 
;     471 
;     472         sec++;
	INC  R12
;     473         if (sec >= 60)
	LDI  R30,LOW(60)
	CP   R12,R30
	BRSH PC+3
	JMP _0xBA
;     474         {
;     475         sec = 0;
	CLR  R12
;     476 
;     477            dat[3] = dat[3]+1;
	__GETB1MN _dat,3
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,3
;     478            if (dat[3] >= 10)
	__GETB2MN _dat,3
	CPI  R26,LOW(0xA)
	BRSH PC+3
	JMP _0xBB
;     479            {
;     480                 dat[3] = 0; //  10  -> 0
	LDI  R30,LOW(0)
	__PUTB1MN _dat,3
;     481                 dat[2] = dat[2] + 1;
	__GETB1MN _dat,2
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,2
;     482 
;     483                 if (dat[2] >= 6)
	__GETB2MN _dat,2
	CPI  R26,LOW(0x6)
	BRSH PC+3
	JMP _0xBC
;     484                 {
;     485                    dat[2] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,2
;     486                    dat[1] = dat[1] + 1;
	__GETB1MN _dat,1
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,1
;     487 
;     488                    if (dat[1] >= 10)
	__GETB2MN _dat,1
	CPI  R26,LOW(0xA)
	BRSH PC+3
	JMP _0xBD
;     489                    {
;     490                      dat[1] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,1
;     491                      dat[0] = dat[0] + 1;
	LDS  R30,_dat
	SUBI R30,-LOW(1)
	STS  _dat,R30
;     492                    }
;     493 
;     494                    if (dat[0] >= 2)
_0xBD:
	LDS  R26,_dat
	CPI  R26,LOW(0x2)
	BRSH PC+3
	JMP _0xBE
;     495                    {
;     496 
;     497                      if (dat[1] >= 4)
	__GETB2MN _dat,1
	CPI  R26,LOW(0x4)
	BRSH PC+3
	JMP _0xBF
;     498                      //    (24 )
;     499                      {
;     500                          dat[1] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,1
;     501                          dat[0] = 0;
	STS  _dat,R30
;     502                          dat[4] = dat[4] + 1;
	__GETB1MN _dat,4
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,4
;     503 
;     504                          if (dat[4] >= 7)  // 
	__GETB2MN _dat,4
	CPI  R26,LOW(0x7)
	BRSH PC+3
	JMP _0xC0
;     505                          {
;     506                             dat[4] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,4
;     507                          }
;     508 
;     509                          dat[6] = dat[6] + 1;
_0xC0:
	__GETB1MN _dat,6
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,6
;     510                          if (dat[6] >= 10)
	__GETB2MN _dat,6
	CPI  R26,LOW(0xA)
	BRSH PC+3
	JMP _0xC1
;     511                          //  10 
;     512                          {
;     513                             dat[6] = 0;           //  
	LDI  R30,LOW(0)
	__PUTB1MN _dat,6
;     514                             dat[5] = dat[5] + 1;  //  
	__GETB1MN _dat,5
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,5
;     515                          }
;     516 
;     517                          //   
;     518                          set_month(3,1,dat[5],dat[6]); //  
_0xC1:
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     519                          set_month(2,8,dat[5],dat[6]); //  
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     520                          set_month(3,1,dat[5],dat[6]); //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     521                          set_month(3,0,dat[5],dat[6]); //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     522                          set_month(3,1,dat[5],dat[6]); //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     523                          set_month(3,0,dat[5],dat[6]); //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     524                          set_month(3,1,dat[5],dat[6]); //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     525                          set_month(3,1,dat[5],dat[6]); //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     526                          set_month(3,0,dat[5],dat[6]); //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     527                          set_month(3,1,dat[5],dat[6]); //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     528                          set_month(3,0,dat[5],dat[6]); //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     529                          set_month(3,1,dat[5],dat[6]); //  
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
;     530 
;     531 
;     532                          if (dat[7] >= 12)  // 12 
	__GETB2MN _dat,7
	CPI  R26,LOW(0xC)
	BRSH PC+3
	JMP _0xC2
;     533                          {
;     534                              dat[7] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,7
;     535 
;     536                              dat[9] = dat[9] + 1;
	__GETB1MN _dat,9
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,9
;     537                              if (dat[9] >= 10)
	__GETB2MN _dat,9
	CPI  R26,LOW(0xA)
	BRSH PC+3
	JMP _0xC3
;     538                              {
;     539                                 dat[9] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,9
;     540                                 dat[8] = dat[8] + 1;
	__GETB1MN _dat,8
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,8
;     541 
;     542                                 if (dat[8] == 10) dat[8] = 0;
	__GETB1MN _dat,8
	CPI  R30,LOW(0xA)
	BREQ PC+3
	JMP _0xC4
	LDI  R30,LOW(0)
	__PUTB1MN _dat,8
;     543                              }
_0xC4:
;     544                          }
_0xC3:
;     545                      }
_0xC2:
;     546                    }
_0xBF:
;     547                 }
_0xBE:
;     548            }
_0xBC:
;     549         }
_0xBB:
;     550 
;     551 
;     552 
;     553 
;     554         if (show_data == 1)
_0xBA:
	LDS  R26,_show_data
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xC5
;     555         {
;     556 
;     557 
;     558             switch (++seconds)
	LDS  R30,_seconds
	SUBI R30,-LOW(1)
	STS  _seconds,R30
;     559             {
;     560                 case 5: seconds = 0;
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0xC8
	LDI  R30,LOW(0)
	STS  _seconds,R30
;     561 
;     562 
;     563 
;     564                      T =  ds1820_temperature_10(0)/10;     // read DS1820 every 5 sec.
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _ds1820_temperature_10
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	STS  _T,R30
	STS  _T+1,R31
;     565 
;     566 
;     567 
;     568                      // 
;     569                      X3=X2;
	LDS  R30,_X2
	LDS  R31,_X2+1
	STS  _X3,R30
	STS  _X3+1,R31
;     570                      X2=T;
	LDS  R30,_T
	LDS  R31,_T+1
	STS  _X2,R30
	STS  _X2+1,R31
;     571                      if (X2==X3)
	LDS  R30,_X3
	LDS  R31,_X3+1
	LDS  R26,_X2
	LDS  R27,_X2+1
	CP   R30,R26
	CPC  R31,R27
	BREQ PC+3
	JMP _0xCA
;     572                      {
;     573 
;     574                            X1=T;
	LDS  R30,_T
	LDS  R31,_T+1
	STS  _X1,R30
	STS  _X1+1,R31
;     575                      }
;     576 
;     577                      T=(X1);
_0xCA:
	LDS  R30,_X1
	LDS  R31,_X1+1
	STS  _T,R30
	STS  _T+1,R31
;     578 
;     579                      put_string(50, 50, "()",BLACK);
	LDI  R30,LOW(50)
	ST   -Y,R30
	ST   -Y,R30
	__POINTW1FN _0,187
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     580 
;     581                      if(T<0)
	LDS  R26,_T
	LDS  R27,_T+1
	SBIW R26,0
	BRLT PC+3
	JMP _0xCB
;     582                      {
;     583 
;     584 
;     585                             // lcd_chr(60, 50, 3); //  
;     586 
;     587                              T = abs(T);   // get only amplitude
	LDS  R30,_T
	LDS  R31,_T+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	STS  _T,R30
	STS  _T+1,R31
;     588 
;     589                              put_char(30, 50,(T%10)+48,BLACK);
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDS  R26,_T
	LDS  R27,_T+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	ADIW R30,48
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     590 
;     591 
;     592 
;     593                              if ((T/10) == 0)
	LDS  R26,_T
	LDS  R27,_T+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	SBIW R30,0
	BREQ PC+3
	JMP _0xCC
;     594                              {
;     595 
;     596                                      put_string(10,50,"-",BLACK);  // put -
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	__POINTW1FN _0,199
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     597                                      put_char(20,50,0,BLACK);
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     598 
;     599                              }
;     600                              else
	RJMP _0xCD
_0xCC:
;     601                              {
;     602 
;     603                                      put_string(10,50,"-",BLACK);    // put -
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	__POINTW1FN _0,199
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     604                                      put_char(20,50,(T/10)+48,BLACK);
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDS  R26,_T
	LDS  R27,_T+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	ADIW R30,48
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     605 
;     606                              }
_0xCD:
;     607 
;     608                      }
;     609                      else
	RJMP _0xCE
_0xCB:
;     610                      {
;     611 
;     612 
;     613                              T = abs(T);   // get only amplitude
	LDS  R30,_T
	LDS  R31,_T+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	STS  _T,R30
	STS  _T+1,R31
;     614 
;     615                              put_char(30, 50,(T%10)+48,BLACK);
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDS  R26,_T
	LDS  R27,_T+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	ADIW R30,48
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     616 
;     617                              if ((T/10) == 0)
	LDS  R26,_T
	LDS  R27,_T+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	SBIW R30,0
	BREQ PC+3
	JMP _0xCF
;     618                              {
;     619                                      put_char(10,50,0,BLACK);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     620                                      put_char(20,50,0,BLACK);
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     621                              }
;     622                              else
	RJMP _0xD0
_0xCF:
;     623                              {
;     624                                      put_char(20,50,(T/10)+48,BLACK);
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDS  R26,_T
	LDS  R27,_T+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	ADIW R30,48
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     625                              }
_0xD0:
;     626 
;     627 
;     628                      }
_0xCE:
;     629 
;     630 
;     631             }
_0xC8:
;     632 
;     633 
;     634 
;     635 
;     636                 //dat[0] - ten hours
;     637                 //dat[1] - one hours
;     638                 //dat[2] - ten minutes
;     639                 //dat[3] - one minutes
;     640                 //dat[4] - week
;     641                 //dat[5] - ten day
;     642                 //dat[6] - one day
;     643                 //dat[7] - month
;     644                 //dat[8] - ten year
;     645                 //dat[9] - one year
;     646 
;     647 
;     648                 put_char(0,1,dat[0] + 48,BLACK);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDS  R30,_dat
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     649                 put_char(9,1,dat[1] + 48,BLACK);
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,1
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     650 
;     651                 put_string(18,1,":",BLACK);
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__POINTW1FN _0,185
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     652 
;     653                 put_char(27,1,dat[2] + 48,BLACK);
	LDI  R30,LOW(27)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,2
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     654                 put_char(36,1,dat[3] + 48,BLACK);
	LDI  R30,LOW(36)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,3
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     655 
;     656                 put_string(56,1,week[dat[4]],BLACK);
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,4
	LDI  R31,0
	LDI  R26,LOW(_week)
	LDI  R27,HIGH(_week)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     657 
;     658                 put_char(0,20,dat[5] + 48,BLACK);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,5
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     659                 put_char(9,20,dat[6] + 48,BLACK);
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,6
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     660 
;     661                 put_string(22,20,month[dat[7]],BLACK);
	LDI  R30,LOW(22)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,7
	LDI  R31,0
	LDI  R26,LOW(_month)
	LDI  R27,HIGH(_month)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_string
;     662 
;     663                 put_char(82,20,50,BLACK);
	LDI  R30,LOW(82)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     664                 put_char(91,20,48,BLACK);
	LDI  R30,LOW(91)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     665 
;     666                 put_char(100,20,dat[8] + 48,BLACK);
	LDI  R30,LOW(100)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,8
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     667                 put_char(109,20,dat[9] + 48,BLACK);
	LDI  R30,LOW(109)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	__GETB1MN _dat,9
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _put_char
;     668 
;     669         }
;     670 
;     671 
;     672 }
_0xC5:
	RETI
;     673 
;     674 
;     675 
;     676 void main(void)
;     677 {
_main:
;     678 // Declare your local variables here
;     679 
;     680 
;     681 
;     682 
;     683 
;     684 // Input/Output Ports initialization
;     685 // Port A initialization
;     686 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     687 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
;     688 PORTA=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     689 DDRA=0xFF;
	OUT  0x1A,R30
;     690 
;     691 // Port B initialization
;     692 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     693 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
;     694 PORTB=0xFF;
	OUT  0x18,R30
;     695 DDRB=0xFF;
	OUT  0x17,R30
;     696 
;     697 // Port C initialization
;     698 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     699 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
;     700 PORTC=0xFF;
	OUT  0x15,R30
;     701 DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
;     702 
;     703 // Port D initialization
;     704 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     705 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
;     706 PORTD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x12,R30
;     707 DDRD=0xFF;
	OUT  0x11,R30
;     708 
;     709 // Port E initialization
;     710 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     711 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
;     712 PORTE=0xFF;
	OUT  0x3,R30
;     713 DDRE=0xFF;
	OUT  0x2,R30
;     714 
;     715 // Port F initialization
;     716 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     717 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
;     718 PORTF=0xFF;
	STS  98,R30
;     719 DDRF=0xFF;
	STS  97,R30
;     720 
;     721 // Port G initialization
;     722 // Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     723 // State4=1 State3=1 State2=1 State1=1 State0=1
;     724 PORTG=0x1F;
	LDI  R30,LOW(31)
	STS  101,R30
;     725 DDRG=0x1F;
	STS  100,R30
;     726 
;     727 //  Timer 0
;     728 //TCCR0=0x00;
;     729 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
;     730 TCNT0=0x64;
	LDI  R30,LOW(100)
	OUT  0x32,R30
;     731 
;     732 //  Timer 1
;     733 TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;     734 TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
;     735 TCNT1H=0xC2;
	LDI  R30,LOW(194)
	OUT  0x2D,R30
;     736 TCNT1L=0xF7;
	LDI  R30,LOW(247)
	OUT  0x2C,R30
;     737 OCR1BL=0x00;
	LDI  R30,LOW(0)
	OUT  0x28,R30
;     738 OCR1BH=0x00;
	OUT  0x29,R30
;     739 OCR1AL=0x00;
	OUT  0x2A,R30
;     740 OCR1AH=0x00;
	OUT  0x2B,R30
;     741 
;     742 // Timer/Counter 2 initialization
;     743 // Clock source: System Clock
;     744 // Clock value: Timer2 Stopped
;     745 // Mode: Normal top=FFh
;     746 // OC2 output: Disconnected
;     747 TCCR2=0x00;
	OUT  0x25,R30
;     748 TCNT2=0x00;
	OUT  0x24,R30
;     749 OCR2=0x00;
	OUT  0x23,R30
;     750 
;     751 // Timer/Counter 3 initialization
;     752 // Clock source: System Clock
;     753 // Clock value: Timer3 Stopped
;     754 // Mode: Normal top=FFFFh
;     755 // OC3A output: Discon.
;     756 // OC3B output: Discon.
;     757 // OC3C output: Discon.
;     758 // Noise Canceler: Off
;     759 // Input Capture on Falling Edge
;     760 // Timer3 Overflow Interrupt: Off
;     761 // Input Capture Interrupt: Off
;     762 // Compare A Match Interrupt: Off
;     763 // Compare B Match Interrupt: Off
;     764 // Compare C Match Interrupt: Off
;     765 TCCR3A=0x00;
	STS  139,R30
;     766 TCCR3B=0x00;
	STS  138,R30
;     767 TCNT3H=0x00;
	STS  137,R30
;     768 TCNT3L=0x00;
	STS  136,R30
;     769 ICR3H=0x00;
	STS  129,R30
;     770 ICR3L=0x00;
	STS  128,R30
;     771 OCR3AH=0x00;
	STS  135,R30
;     772 OCR3AL=0x00;
	STS  134,R30
;     773 OCR3BH=0x00;
	STS  133,R30
;     774 OCR3BL=0x00;
	STS  132,R30
;     775 OCR3CH=0x00;
	STS  131,R30
;     776 OCR3CL=0x00;
	STS  130,R30
;     777 
;     778 // External Interrupt(s) initialization
;     779 // INT0: Off
;     780 // INT1: Off
;     781 // INT2: Off
;     782 // INT3: Off
;     783 // INT4: Off
;     784 // INT5: Off
;     785 // INT6: Off
;     786 // INT7: Off
;     787 EICRA=0x00;
	STS  106,R30
;     788 EICRB=0x00;
	OUT  0x3A,R30
;     789 EIMSK=0x00;
	OUT  0x39,R30
;     790 
;     791 // Timer(s)/Counter(s) Interrupt(s) initialization
;     792 TIMSK = 0b101;
	LDI  R30,LOW(5)
	OUT  0x37,R30
;     793 ETIMSK=0x00;
	LDI  R30,LOW(0)
	STS  125,R30
;     794 
;     795 // Analog Comparator initialization
;     796 // Analog Comparator: Off
;     797 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     798 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     799 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     800 
;     801 
;     802 
;     803 
;     804 // spi
;     805 SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
;     806 SPSR=0x01;
	LDI  R30,LOW(1)
	OUT  0xE,R30
;     807 
;     808 
;     809 
;     810 
;     811         //dat[0] - ten hours
;     812         //dat[1] - one hours
;     813         //dat[2] - ten minutes
;     814         //dat[3] - one minutes
;     815         //dat[4] - week
;     816         //dat[5] - ten day
;     817         //dat[6] - one day
;     818         //dat[7] - month
;     819         //dat[8] - ten year
;     820         //dat[9] - one year
;     821           dat[0] = 0;
	LDI  R30,LOW(0)
	STS  _dat,R30
;     822           dat[1] = 0;
	__PUTB1MN _dat,1
;     823           dat[2] = 0;
	__PUTB1MN _dat,2
;     824           dat[3] = 0;
	__PUTB1MN _dat,3
;     825           dat[4] = 1;
	LDI  R30,LOW(1)
	__PUTB1MN _dat,4
;     826           dat[5] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,5
;     827           dat[6] = 7;
	LDI  R30,LOW(7)
	__PUTB1MN _dat,6
;     828           dat[7] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,7
;     829           dat[8] = 1;
	LDI  R30,LOW(1)
	__PUTB1MN _dat,8
;     830           dat[9] = 1;
	__PUTB1MN _dat,9
;     831 
;     832 
;     833 
;     834 
;     835       X1=0;
	LDI  R30,0
	STS  _X1,R30
	STS  _X1+1,R30
;     836       X2=0;
	LDI  R30,0
	STS  _X2,R30
	STS  _X2+1,R30
;     837       X3=0;
	LDI  R30,0
	STS  _X3,R30
	STS  _X3+1,R30
;     838       T = 0;
	LDI  R30,0
	STS  _T,R30
	STS  _T+1,R30
;     839 
;     840 seconds = 0;
	LDI  R30,LOW(0)
	STS  _seconds,R30
;     841 
;     842 focus = 0;
	STS  _focus,R30
;     843 
;     844 show_data = 1;
	LDI  R30,LOW(1)
	STS  _show_data,R30
;     845 
;     846 time = 0;
	LDI  R30,LOW(0)
	STS  _time,R30
;     847 
;     848 // 1 Wire Bus initialization
;     849    w1_init();
	CALL _w1_init
;     850 
;     851 
;     852 #asm("sei")
	sei
;     853 
;     854 
;     855 LS020_lcd_init();
	CALL _LS020_lcd_init
;     856 
;     857 
;     858 
;     859 
;     860 srand(120);
	LDI  R30,LOW(120)
	LDI  R31,HIGH(120)
	ST   -Y,R31
	ST   -Y,R30
	CALL _srand
;     861 
;     862 lcd_cputpixel(2,174, BLUE);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(174)
	LDI  R31,HIGH(174)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(31)
	LDI  R31,HIGH(31)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_cputpixel
;     863 
;     864 
;     865 while (1)
_0xD1:
;     866 {
;     867 
;     868 //                delay_ms(100);
;     869 //                put_string(1, 1, text, BLACK);
;     870 
;     871 }
	RJMP _0xD1
_0xD3:
;     872 }
_0xD4:
	RJMP _0xD4

	.DSEG
_96:
	.BYTE 0x60
_98:
	.BYTE 0x54
_100:
	.BYTE 0x0A

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x780
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x4B
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USW 0x130
	sbis __w1_port-2,__w1_bit
	inc  r30
	__DELAY_USW 0x618
	ret

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ADDD21:
	ADD  R26,R30
	ADC  R27,R31
	ADC  R24,R22
	ADC  R25,R23
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
