
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega64
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 1024 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega64
	#pragma AVRPART MEMORY PROG_FLASH 65536
	#pragma AVRPART MEMORY EEPROM 2048
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _backcolor=R4
	.DEF _textcolor=R6
	.DEF _TEXT_cursorX=R8
	.DEF _TEXT_cursorY=R10
	.DEF _ls020isready=R13
	.DEF _sec=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_ovf_isr
	JMP  0x00
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_ascii_tab:
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0xE,0xE,0xE
	.DB  0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x0,0x0,0x0,0x3,0x3,0x3,0x0,0x0
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x0,0x0,0x0,0x80,0x80,0x80,0x0,0x0
	.DB  0x1C,0x1C,0x1C,0x1C,0x1C,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x70,0x70,0x70,0x70,0x70,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x1C,0x1C,0x1C,0xFF,0xFF,0xFF,0x1C
	.DB  0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0xFF,0xFF
	.DB  0xFF,0x1C,0x1C,0x1C,0x0,0x0,0x0,0x0
	.DB  0x0,0x70,0x70,0x70,0xFE,0xFE,0xFE,0x70
	.DB  0x70,0x70,0x70,0x70,0x70,0x70,0xFE,0xFE
	.DB  0xFE,0x70,0x70,0x70,0x0,0x0,0x0,0x0
	.DB  0x1,0x1,0x7,0xF,0x1F,0x3C,0x38,0x38
	.DB  0x38,0x1F,0xF,0x0,0x0,0x0,0x38,0x3C
	.DB  0x1F,0xF,0x7,0x1,0x1,0x0,0x0,0x0
	.DB  0x80,0x80,0xE0,0xF0,0xF8,0x38,0x0,0x0
	.DB  0x0,0xE0,0xF0,0x78,0x38,0x38,0x38,0x78
	.DB  0xF0,0xE0,0xC0,0x80,0x80,0x0,0x0,0x0
	.DB  0x0,0x0,0x38,0x28,0x38,0x1,0x3,0x7
	.DB  0xE,0x1C,0x38,0x70,0x60,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x38,0x70,0xE0,0xC0,0x80,0x0
	.DB  0x0,0x70,0x50,0x70,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xF,0x1F,0x3F,0x78,0x70,0x70,0x38,0x1D
	.DB  0xF,0xF,0x1F,0x3F,0x78,0x70,0x78,0x3F
	.DB  0x1F,0xF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x80,0xC0,0xE0,0xF0,0x70,0x70,0xE0,0xC0
	.DB  0x80,0x88,0xDC,0xFC,0xF8,0x78,0xFC,0xFC
	.DB  0xCC,0x80,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x7,0x7,0x7,0x7,0xE,0x1C,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1,0x3,0x7,0xE,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0xE,0x7,0x3,0x1,0x0,0x0
	.DB  0xC0,0x80,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x80,0xC0,0x0,0x0
	.DB  0x7,0x3,0x1,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x1,0x3,0x7,0x0,0x0
	.DB  0x0,0x80,0xC0,0xE0,0x70,0x70,0x70,0x70
	.DB  0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70
	.DB  0x70,0x70,0xE0,0xC0,0x80,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x63,0x73,0x3B,0x1F,0xF
	.DB  0x7F,0x7F,0x7F,0xF,0x1F,0x3B,0x73,0x63
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x8C,0x9C,0xB8,0xF0,0xE0
	.DB  0xFC,0xFC,0xFC,0xE0,0xF0,0xB8,0x9C,0x8C
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x3,0x3,0x3,0x3,0x3
	.DB  0x7F,0x7F,0x7F,0x3,0x3,0x3,0x3,0x3
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x80,0x80,0x80,0x80,0x80
	.DB  0xFC,0xFC,0xFC,0x80,0x80,0x80,0x80,0x80
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1,0x1,0x1,0x3,0x7,0xE,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xC0,0xC0,0xC0,0x80,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x7F,0x7F,0x7F,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xF8,0xF8,0xF8,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x3,0x3,0x3,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x80,0x80,0x80,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x1,0x3,0x7,0xE,0x1C,0x38
	.DB  0x70,0x60,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0xC,0x1C,0x38
	.DB  0x70,0xE0,0xC0,0x80,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xE0,0xF0,0xF8,0x3C,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x3C,0xF8,0xF0,0xE0,0x0,0x0
	.DB  0x3,0x7,0xF,0x1F,0x3B,0x73,0xE3,0xC3
	.DB  0x83,0x3,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0xFC,0xFC,0xFC,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x1F,0x3F,0x7F,0xF0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0xE0,0xF0,0xF8,0x3C,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0xFC,0xFC,0xFC,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFC,0xFC,0xFC,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xE0,0xF0,0xF8,0x3C,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x3C,0x70,0x70,0x3C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x3C,0xF8,0xF0,0xE0,0x0,0x0
	.DB  0x0,0x0,0x1,0x3,0x7,0xF,0x1E,0x3C
	.DB  0x78,0x70,0x7F,0x7F,0x7F,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x7C,0xFC,0xFC,0xDC,0x9C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0xFC,0xFC,0xFC,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xFC,0xFC,0xFC,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xE0,0xF0,0xF8,0x3C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x3C,0xF8,0xF0,0xE0,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xFF,0xFF,0xFF,0xF0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xE0,0xF0,0xF8,0x3C,0x0,0x0,0x0,0x0
	.DB  0x0,0xE0,0xF0,0xF8,0x3C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x3C,0xF8,0xF0,0xE0,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0,0x1
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x0,0x0
	.DB  0xFC,0xFC,0xFC,0x1C,0x38,0x70,0xE0,0xC0
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xF0,0xFF,0x3F,0x3F,0xF0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xE0,0xF0,0xF8,0x3C,0x1C,0x1C,0x1C,0x1C
	.DB  0x3C,0xFC,0xF0,0xF0,0x3C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x3C,0xF8,0xF0,0xE0,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xF0,0x7F,0x3F,0x1F,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xE0,0xF0,0xF8,0x3C,0x1C,0x1C,0x1C,0x1C
	.DB  0x3C,0xFC,0xFC,0xFC,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x3C,0xF8,0xF0,0xE0,0x0,0x0
	.DB  0x0,0x0,0x3,0x3,0x3,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x3,0x3,0x3
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x80,0x80,0x80,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x80,0x80,0x80
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x3,0x3,0x3,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x3,0x3,0x3
	.DB  0x7,0xE,0x1C,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x80,0x80,0x80,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x80,0x80,0x80
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x1,0x3,0x7,0xE
	.DB  0x1C,0x38,0x30,0x38,0x1C,0xE,0x7,0x3
	.DB  0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x30,0x70,0xE0,0xC0,0x80,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80
	.DB  0xC0,0xE0,0x70,0x30,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x7F,0x7F,0x7F
	.DB  0x0,0x0,0x0,0x0,0x7F,0x7F,0x7F,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0xF8,0xF8,0xF8
	.DB  0x0,0x0,0x0,0x0,0xF8,0xF8,0xF8,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0xC,0xE,0x7,0x3
	.DB  0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x1
	.DB  0x3,0x7,0xE,0xC,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80
	.DB  0xC0,0xE0,0x70,0x38,0x38,0x70,0xE0,0xC0
	.DB  0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF,0x1F,0x3F,0x38,0x0,0x0,0x0
	.DB  0x0,0x1,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x0,0x0,0x0,0x3,0x3,0x3,0x0,0x0
	.DB  0x0,0xC0,0xE0,0xF0,0x38,0x38,0x38,0x70
	.DB  0xE0,0xC0,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x0,0x0,0x0,0x80,0x80,0x80,0x0,0x0
	.DB  0x0,0x0,0x0,0x3F,0x7F,0xE0,0xC0,0xCF
	.DB  0xDF,0xD8,0xD8,0xD8,0xD8,0xD8,0xDF,0xCF
	.DB  0xC0,0xE0,0x7F,0x3F,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xE0,0xF0,0x30,0x30,0xB0
	.DB  0xF0,0x70,0x70,0x70,0x70,0x70,0xF0,0xB0
	.DB  0x30,0x0,0xF0,0xF0,0x0,0x0,0x0,0x0
	.DB  0x3,0x7,0xF,0x1E,0x3C,0x78,0xF0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xFF,0xFF,0xFF,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0x80,0xC0,0xE0,0xF0,0x78,0x3C,0x1E,0xE
	.DB  0xE,0xE,0xE,0xE,0xFE,0xFE,0xFE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xFF,0xFF,0xFF,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xFC,0xF8,0xFC,0xE,0xE,0xE
	.DB  0xE,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xFE,0xFE,0xFE,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF0,0xF0,0xF0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFE,0xFE,0xFE,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF0,0xF0,0xF0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xFE,0xFE
	.DB  0xFE,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xFE,0xFE,0xFE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0x0,0x0
	.DB  0x1F,0x1F,0x1F,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x1F,0x1F,0x1F,0x0,0x0
	.DB  0xF0,0xF0,0xF0,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0xF0,0xF0,0xF0,0x0,0x0
	.DB  0x3F,0x3F,0x3F,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x1,0x3F,0x3F,0x3C,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xC0,0xC0,0x80,0x0,0x0,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE1,0xE3,0xE7
	.DB  0xEE,0xFC,0xF8,0xF8,0xFC,0xEE,0xE7,0xE3
	.DB  0xE1,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xC,0x1C,0x38,0x70,0xE0,0xC0,0x80,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80
	.DB  0xC0,0xE0,0x70,0x38,0x1C,0xC,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFE,0xFE,0xFE,0x0,0x0
	.DB  0xF0,0xF0,0xF8,0xF8,0xEC,0xEC,0xE6,0xE7
	.DB  0xE3,0xE3,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0x1E,0x1E,0x3E,0x3E,0x6E,0x6E,0xCE,0xCE
	.DB  0x8E,0x8E,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0x0,0x0
	.DB  0xE0,0xE0,0xF0,0xF8,0xF8,0xF8,0xEC,0xEC
	.DB  0xE6,0xE2,0xE3,0xE3,0xE1,0xE1,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0x8E,0xCE,0xCE,0xCE
	.DB  0x6E,0x6E,0x3E,0x3E,0x1E,0x1E,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xFF,0xFF,0xFF,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0xE,0xE,0xE
	.DB  0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xCE
	.DB  0xEE,0x7E,0x3E,0xFC,0xFE,0xF6,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xFF,0xFF,0xFF,0xE7,0xE3,0xE1
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0xE,0xE,0xE
	.DB  0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x80,0xC0
	.DB  0xE0,0x70,0x38,0x1C,0xE,0x6,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xF0,0xFF,0x7F,0x3F,0x0,0x0,0x0,0x0
	.DB  0x0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0x0,0x0,0x0
	.DB  0x0,0xF0,0xF8,0xFC,0x1E,0xE,0xE,0xE
	.DB  0xE,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0x70,0x70,0x70,0x70
	.DB  0x38,0x38,0x38,0x38,0x1C,0x1C,0x1C,0x1C
	.DB  0xE,0xE,0xE,0xE,0x3,0x3,0x0,0x0
	.DB  0xE,0xE,0xE,0xE,0x1C,0x1C,0x1C,0x1C
	.DB  0x38,0x38,0x38,0x38,0x70,0x70,0x70,0x70
	.DB  0xE0,0xE0,0xE0,0xE0,0x0,0x0,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE1
	.DB  0xE3,0xE7,0xEE,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0x8E,0xCE,0xEE,0x7E,0x3E,0x1E,0x0,0x0
	.DB  0xC0,0xE0,0xF0,0x70,0x38,0x18,0x1C,0xC
	.DB  0xE,0x7,0x3,0x7,0xE,0xC,0x1C,0x18
	.DB  0x38,0x70,0xF0,0xE0,0xC0,0x0,0x0,0x0
	.DB  0x6,0xE,0x1E,0x1C,0x38,0x38,0x70,0x60
	.DB  0xE0,0xC0,0x80,0xC0,0xE0,0x60,0x70,0x30
	.DB  0x38,0x1C,0x1E,0xE,0x6,0x0,0x0,0x0
	.DB  0xC0,0xE0,0xF0,0x70,0x38,0x18,0x1C,0xC
	.DB  0xE,0x7,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x0,0x0
	.DB  0x6,0xE,0x1E,0x1C,0x38,0x38,0x70,0x60
	.DB  0xE0,0xC0,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x1,0x3,0x7,0xF,0x1E,0x3C
	.DB  0x78,0xF0,0xE0,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0x6,0xE,0x1E,0x3C,0x78
	.DB  0xF0,0xE0,0xC0,0x80,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFE,0xFE,0xFE,0x0,0x0
	.DB  0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7
	.DB  0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7
	.DB  0x7,0x7,0x7,0x7,0x7,0x7,0x7,0x7
	.DB  0xF0,0xF0,0xF0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0xF0,0xF0,0xF0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xF,0xF,0xF,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0xF,0xF,0xF
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0x1,0x3,0x7,0xE,0x1C,0x38,0x70,0x60
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x80,0xC0,0xE0,0x70,0x38,0x1C,0xE,0x6
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x7F,0x7F,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0xFE,0xFE,0x0,0x0
	.DB  0x3,0x3,0x3,0x7,0xE,0x1C,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x80,0x80,0x80,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF,0x1F,0x38,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0x30,0x38,0x1F,0xF,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x98,0xF8,0x78,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x78,0xFE,0x9E,0x0,0x0
	.DB  0x0,0x30,0x30,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0x3F,0x3F,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0x30,0x30,0x3F,0x3F,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x38,0x18,0x18,0x18
	.DB  0x18,0x18,0x38,0x78,0xF0,0xE0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x7,0xF,0x1C,0x38,0x30,0x30,0x30
	.DB  0x30,0x30,0x38,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x38,0x0,0x0,0x0
	.DB  0x0,0x0,0x38,0x70,0xE0,0xC0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x7,0xF,0x1C,0x38,0x30,0x30,0x30
	.DB  0x30,0x30,0x38,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x30,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0xF0,0xF0,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0x30,0x30,0xF0,0xF0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x7,0xF,0x1C,0x38,0x30,0x3F,0x3F
	.DB  0x30,0x30,0x38,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x38,0x18,0xF8,0xF8
	.DB  0x0,0x0,0x38,0x78,0xF0,0xE0,0x0,0x0
	.DB  0x0,0x0,0x0,0x1,0x1,0x1,0x1,0x1
	.DB  0x1,0xF,0xF,0x1,0x1,0x1,0x1,0x1
	.DB  0x1,0x1,0x1,0x1,0x1,0x1,0x0,0x0
	.DB  0x78,0xF8,0xE0,0xC0,0xC0,0x80,0x80,0x80
	.DB  0x80,0xF0,0xF0,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF,0x1F,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0x3F,0x1F,0x0,0x0,0x3F,0x3F
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x30,0xF0,0xF0,0x30,0x30,0x30,0x30
	.DB  0x30,0xF0,0xF0,0x30,0x30,0x30,0xF0,0xE0
	.DB  0x0,0x0,0x18,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x19,0x1F,0x1E,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xE0,0xF0,0x38,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x1
	.DB  0x0,0x1,0x1,0x1,0x1,0x1,0x1,0x1
	.DB  0x1,0x1,0x1,0x1,0x1,0x1,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x80
	.DB  0x0,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x1
	.DB  0x0,0x1,0x1,0x1,0x1,0x1,0x1,0x1
	.DB  0x1,0x1,0x1,0x1,0x3,0x7,0x1E,0x1C
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x80
	.DB  0x0,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x0,0x0,0x0
	.DB  0x0,0x0,0x18,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x18,0x19,0x1B,0x1F,0x1E
	.DB  0x1F,0x1B,0x19,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x30,0x70,0xE0,0xC0,0x80,0x0,0x0
	.DB  0x0,0x80,0xC0,0xE0,0x70,0x30,0x0,0x0
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x66,0x7F,0x79,0x61,0x61,0x61,0x61
	.DB  0x61,0x61,0x61,0x61,0x61,0x61,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x60,0xF8,0x9C,0x8C,0x8C,0x8C,0x8C
	.DB  0x8C,0x8C,0x8C,0x8C,0x8C,0x8C,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x19,0x1F,0x1E,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xE0,0xF0,0x38,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF,0x1F,0x38,0x30,0x30,0x30,0x30
	.DB  0x30,0x38,0x1F,0xF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x30,0x30,0x30,0x30
	.DB  0x30,0x70,0xE0,0xC0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x3F,0x3F,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0x3F,0x3F,0x30,0x30,0x30,0x30
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x30,0x30,0x30,0x30
	.DB  0x30,0x70,0xE0,0xC0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF,0x1F,0x38,0x30,0x30,0x30,0x30
	.DB  0x30,0x38,0x1F,0xF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x30,0xF0,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0xF0,0x30,0x30,0x30,0x30,0x30
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x19,0x1F,0x1E,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xE0,0xF0,0x38,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF,0x1F,0x38,0x30,0x38,0x3F,0x1F
	.DB  0x0,0x0,0x30,0x38,0x1F,0xF,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x0,0x0,0xC0,0xE0
	.DB  0x70,0x30,0x30,0x70,0xE0,0xC0,0x0,0x0
	.DB  0x0,0x0,0x6,0x6,0x6,0x6,0x6,0x6
	.DB  0x6,0x3F,0x3F,0x6,0x6,0x6,0x6,0x6
	.DB  0x6,0x6,0x7,0x3,0x1,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xC0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x80,0xF0,0xF0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x38,0xF0,0xE0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x18,0x18,0x18,0x18,0xC
	.DB  0xC,0xC,0xC,0x6,0x6,0x3,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x30,0x30,0x30,0x30,0x60
	.DB  0x60,0x60,0x60,0xC0,0xC0,0x80,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x19,0x19,0x1B,0x1E,0x1C,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x98,0x98,0xF8,0x78,0x38,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x1C,0x1E,0x6,0x3,0x1,0x1
	.DB  0x3,0x6,0x1E,0x1C,0x18,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x38,0x78,0x60,0xC0,0x80,0x80
	.DB  0xC0,0x60,0x78,0x38,0x18,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x1C,0xF
	.DB  0x7,0x0,0x0,0x0,0x0,0x0,0x1F,0x1F
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x18,0xF8
	.DB  0xF8,0x18,0x18,0x18,0x18,0x38,0xF0,0xE0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x1F,0x1F,0x0,0x0,0x0,0x0,0x1
	.DB  0x3,0x6,0xC,0x18,0x1F,0x1F,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF8,0xF8,0x18,0x30,0x60,0xC0,0x80
	.DB  0x0,0x0,0x0,0x0,0xF8,0xF8,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x3,0x7,0xF,0x1E,0x3C,0x78,0xF0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xFF,0xFF,0xFF,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0x80,0xC0,0xE0,0xF0,0x78,0x3C,0x1E,0xE
	.DB  0xE,0xE,0xE,0xE,0xFE,0xFE,0xFE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF0,0xF8,0xFC,0x1E,0xE,0xE,0xE
	.DB  0xE,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xFF,0xFF,0xFF,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xFC,0xF8,0xFC,0xE,0xE,0xE
	.DB  0xE,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x7,0xF,0x1F,0x1C,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xF0,0xF0,0xF0,0x70,0x70,0x70,0x70,0x70
	.DB  0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70
	.DB  0xFE,0xFE,0xFE,0xE,0xE,0xE,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF0,0xF0,0xF0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFE,0xFE,0xFE,0x0,0x0
	.DB  0xC3,0xE3,0xF3,0xFB,0x7F,0x3F,0x1F,0xF
	.DB  0xF,0x7,0x3,0x3,0x7,0xF,0xF,0x1F
	.DB  0x3F,0x7F,0xFB,0xF3,0xE3,0xC3,0x0,0x0
	.DB  0x86,0x8E,0x9E,0xBE,0xFC,0xF8,0xF0,0xE0
	.DB  0xC0,0x80,0x0,0x0,0x80,0xC0,0xE0,0xF0
	.DB  0xF8,0xFC,0xBE,0x9E,0x8E,0x86,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0
	.DB  0xF0,0xF8,0xFC,0x1C,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x3C,0x70,0x70,0x3C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x1C,0x1C,0xF8,0xF0,0xE0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE1,0xE1
	.DB  0xE1,0xE3,0xE3,0xE3,0xE7,0xE7,0xE7,0xEE
	.DB  0xEE,0xFE,0xFC,0xFC,0xF0,0xF0,0x0,0x0
	.DB  0x3C,0x3C,0xFC,0xFC,0xFC,0xDC,0xDC,0xDC
	.DB  0xDC,0x9C,0x9C,0x9C,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x0
	.DB  0xE7,0xE0,0xE0,0xE0,0xE0,0xE0,0xE1,0xE1
	.DB  0xE1,0xE3,0xE3,0xE3,0xE7,0xE7,0xE7,0xEE
	.DB  0xEE,0xFE,0xFC,0xFC,0xF0,0xF0,0x0,0x0
	.DB  0xBC,0x3C,0xFC,0xFC,0xFC,0xDC,0xDC,0xDC
	.DB  0xDC,0x9C,0x9C,0x9C,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE1,0xE3,0xE7
	.DB  0xEE,0xFC,0xF8,0xF8,0xFC,0xEE,0xE7,0xE3
	.DB  0xE1,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xC,0x1C,0x38,0x70,0xE0,0xC0,0x80,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80
	.DB  0xC0,0xE0,0x70,0x38,0x1C,0xC,0x0,0x0
	.DB  0xF,0x1F,0x3F,0x3C,0x38,0x38,0x38,0x38
	.DB  0x38,0x38,0x38,0x38,0x38,0x38,0x38,0x38
	.DB  0x38,0x38,0x38,0xF8,0xF0,0xE0,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0x0,0x0
	.DB  0xF0,0xF0,0xF8,0xF8,0xEC,0xEC,0xE6,0xE7
	.DB  0xE3,0xE3,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0x1E,0x1E,0x3E,0x3E,0x6E,0x6E,0xCE,0xCE
	.DB  0x8E,0x8E,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xFE,0xFE,0xFE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xFF,0xFF,0xFF,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0xE,0xE,0xE
	.DB  0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xF0,0xFF,0x7F,0x3F,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xFE,0xFE,0xFE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xE3,0xE3,0xE3,0xE3,0xE3
	.DB  0xF3,0xFF,0x7F,0x3F,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x8E,0x8E,0x8E,0x8E,0x8E
	.DB  0x9E,0xFC,0xF8,0xF0,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x0,0x0
	.DB  0xC0,0xE0,0xF0,0x70,0x38,0x18,0x1C,0xC
	.DB  0xE,0x7,0x3,0x7,0xE,0xC,0x1C,0x18
	.DB  0x38,0x70,0xF0,0xE0,0xC0,0x0,0x0,0x0
	.DB  0x6,0xE,0x1E,0x1C,0x38,0x38,0x70,0x60
	.DB  0xE0,0xC0,0x80,0xC0,0xE0,0x60,0x70,0x30
	.DB  0x38,0x1C,0x1E,0xE,0x6,0x0,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xFF,0xFF,0xFF,0x0,0x0,0x0
	.DB  0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C
	.DB  0x1C,0x1C,0xFC,0xFE,0xFE,0x1E,0x1E,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xF0,0x7F,0x3F,0x1F,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xFE,0xFE,0xFE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0x0,0x0
	.DB  0xE3,0xE3,0xE3,0xE3,0xE3,0xE3,0xE3,0xE3
	.DB  0xE3,0xE3,0xE3,0xE3,0xE3,0xE3,0xE3,0xE3
	.DB  0xE3,0xE3,0xE3,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0x8E,0x8E,0x8E,0x8E,0x8E,0x8E,0x8E,0x8E
	.DB  0x8E,0x8E,0x8E,0x8E,0x8E,0x8E,0x8E,0x8E
	.DB  0x8E,0x8E,0x8E,0xFE,0xFE,0xFE,0x0,0x0
	.DB  0xE3,0xE3,0xE3,0xE3,0xE3,0xE3,0xE3,0xE3
	.DB  0xE3,0xE3,0xE3,0xE3,0xE3,0xE3,0xE3,0xE3
	.DB  0xE3,0xE3,0xE3,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0x8E,0x8E,0x8E,0x8E,0x8E,0x8E,0x8E,0x8E
	.DB  0x8E,0x8E,0x8E,0x8E,0x8E,0x8E,0x8E,0x8E
	.DB  0x8E,0x8E,0x8E,0xFE,0xFE,0xFE,0x1E,0x1E
	.DB  0xF0,0xF0,0xF0,0x70,0x70,0x70,0x70,0x70
	.DB  0x7F,0x7F,0x7F,0x70,0x70,0x70,0x70,0x70
	.DB  0x70,0x70,0x70,0x7F,0x7F,0x7F,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xFF,0xFF,0xFF,0xE1,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE1,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0x8E,0xCE,0xEE,0xEE,0xEE,0xEE
	.DB  0xEE,0xEE,0xEE,0xCE,0x8E,0xE,0x0,0x0
	.DB  0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xFF,0xFF,0xFF,0xE0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xE0,0xE0,0xFF,0xFF,0xFF,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x1E,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0x1E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0xFE,0xFF,0xFF,0x1,0x0,0x0,0x0,0x0
	.DB  0x0,0x3F,0x3F,0x3F,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x1,0xFF,0xFF,0xFE,0x0,0x0
	.DB  0x0,0xE0,0xF0,0xF8,0x3C,0x1E,0xE,0xE
	.DB  0xE,0xFE,0xFE,0xFE,0xE,0xE,0xE,0xE
	.DB  0x1E,0x3C,0xF8,0xF0,0xE0,0x0,0x0,0x0
	.DB  0xE0,0xE1,0xE3,0xE7,0xE7,0xE7,0xE7,0xE7
	.DB  0xE7,0xE7,0xFF,0xFF,0xFF,0xE7,0xE7,0xE7
	.DB  0xE7,0xE7,0xE7,0xE3,0xE1,0xE0,0x0,0x0
	.DB  0xF0,0xF8,0xFC,0x9E,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0x9E,0xFC,0xF8,0xF0,0x0,0x0
	.DB  0x1F,0x3F,0x7F,0xF0,0xE0,0xE0,0xE0,0xE0
	.DB  0xE0,0xF0,0x7F,0x3F,0x1F,0x0,0x1,0x3
	.DB  0x7,0xF,0x1E,0x3C,0x78,0xF0,0x0,0x0
	.DB  0xFE,0xFE,0xFE,0xE,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0xFE,0xFE,0xFE,0xFE,0xEE,0xCE
	.DB  0x8E,0xE,0xE,0xE,0xE,0xE,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF,0x1F,0x38,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0x30,0x38,0x1F,0xF,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x98,0xF8,0x78,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x78,0xFE,0x9E,0x0,0x0
	.DB  0x0,0x0,0x0,0x7,0xF,0x1C,0x18,0x18
	.DB  0x18,0x1F,0x1F,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x18,0x38,0xF0,0xE0,0x0,0x0,0x0
	.DB  0x0,0xE0,0xF0,0x38,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x38,0xF0,0xE0,0x0,0x0
	.DB  0x7,0xF,0x1C,0x18,0x18,0x19,0x1B,0x1F
	.DB  0x1E,0x1F,0x1F,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x1C,0xF,0x7,0x0,0x0
	.DB  0x80,0xC0,0xE0,0x60,0xE0,0xC0,0x80,0x0
	.DB  0x0,0xE0,0xF0,0x38,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x38,0xF0,0xE0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x7,0xF,0x1C,0x0,0x0,0x7,0xF
	.DB  0x1C,0x18,0x18,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x30,0x70,0xE0,0xC0
	.DB  0x0,0x0,0x0,0x70,0xE0,0xC0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF,0x1F,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x7F,0x7F,0x60,0x60,0x60,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xE0,0xF0,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0xFC,0xFC,0xC,0xC,0xC,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x7,0xF,0x1C,0x18,0x18,0x1F,0x1F
	.DB  0x18,0x18,0x18,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x30,0x30,0xF0,0xF0
	.DB  0x0,0x0,0x0,0x70,0xE0,0xC0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x6,0x6
	.DB  0x0,0x7,0xF,0x1C,0x18,0x18,0x1F,0x1F
	.DB  0x18,0x18,0x18,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xC0,0xC0
	.DB  0x0,0xC0,0xE0,0x70,0x30,0x30,0xF0,0xF0
	.DB  0x0,0x0,0x0,0x70,0xE0,0xC0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x61,0x71,0x39,0x1D,0xF,0x7,0x3
	.DB  0x7,0xF,0x1D,0x39,0x71,0x61,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x86,0x8E,0x9C,0xB8,0xF0,0xE0,0xC0
	.DB  0xE0,0xF0,0xB8,0x9C,0x8E,0x86,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x7,0xF,0x1C,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x30,0x30,0x60,0x60
	.DB  0x30,0x30,0x30,0x70,0xE0,0xC0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x19,0x19
	.DB  0x1B,0x1B,0x1E,0x1E,0x1C,0x1C,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x38,0x38,0x78,0x78,0xD8,0xD8,0x98
	.DB  0x98,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3
	.DB  0x3,0x18,0x18,0x18,0x18,0x18,0x19,0x19
	.DB  0x1B,0x1B,0x1E,0x1E,0x1C,0x1C,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80
	.DB  0x80,0x38,0x38,0x78,0x78,0xD8,0xD8,0x98
	.DB  0x98,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x19,0x1B,0x1F,0x1E
	.DB  0x1F,0x1B,0x19,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x30,0x70,0xE0,0xC0,0x80,0x0,0x0
	.DB  0x0,0x80,0xC0,0xE0,0x70,0x30,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x7,0xF,0x1C,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x38,0x70,0x60,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF8,0xF8,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x1C,0x1E,0x1B,0x19,0x19,0x18,0x18
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x38,0x78,0xD8,0x98,0x98,0x18,0x18
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x1F,0x1F
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0xF8,0xF8
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x7,0xF,0x1C,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0x30,0x70,0xE0,0xC0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x1F,0x1F,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF0,0xF0,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0x30,0x30,0x30,0x30,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x1F,0x1F,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x1F,0x1F,0x18,0x18,0x18
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0x70,0xE0,0xC0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x7,0xF,0x1C,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x70,0xE0,0xC0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x1F,0x1F,0x1,0x1,0x1,0x1,0x1
	.DB  0x1,0x1,0x1,0x1,0x1,0x1,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF8,0xF8,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x1C,0xF,0x7
	.DB  0x0,0x0,0x0,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0xF8,0xF8
	.DB  0x18,0x18,0x18,0x38,0xF0,0xE0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x7,0xF,0x1D,0x19,0x19,0x19,0x1D
	.DB  0xF,0x7,0x1,0x1,0x1,0x1,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xE0,0xF0,0xB8,0x98,0x98,0x98,0xB8
	.DB  0xF0,0xE0,0x80,0x80,0x80,0x80,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0xC,0xC,0x6,0x7,0x3
	.DB  0x7,0x6,0xC,0xC,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x30,0x30,0x60,0xE0,0xC0
	.DB  0xE0,0x60,0x30,0x30,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x1C,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x18,0x18
	.DB  0x18,0x18,0x18,0x18,0xFC,0xFC,0x1C,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x1C,0xF,0x7
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0xF8,0xF8
	.DB  0x18,0x18,0x18,0x18,0x18,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x19,0x19,0x19,0x19,0x19,0x19,0x19
	.DB  0x19,0x19,0x19,0x1D,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x98,0x98,0x98,0x98,0x98,0x98,0x98
	.DB  0x98,0x98,0x98,0x98,0xF8,0xF8,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x19,0x19,0x19,0x19,0x19,0x19,0x19
	.DB  0x19,0x19,0x19,0x1D,0xF,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x98,0x98,0x98,0x98,0x98,0x98,0x98
	.DB  0x98,0x98,0x98,0x98,0xFC,0xFC,0x1C,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x1E,0x1E,0x6,0x6,0x6,0x7,0x7
	.DB  0x6,0x6,0x6,0x6,0x7,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xE0,0xF0
	.DB  0x38,0x18,0x18,0x38,0xF0,0xE0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x1F,0x1F
	.DB  0x19,0x18,0x18,0x19,0x1F,0x1F,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x18,0x18,0x18,0x18,0x18,0x98,0xD8
	.DB  0xD8,0xD8,0xD8,0xD8,0x98,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x6,0x6,0x6,0x6,0x6,0x7,0x7
	.DB  0x6,0x6,0x6,0x6,0x7,0x7,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xE0,0xF0
	.DB  0x38,0x18,0x18,0x38,0xF0,0xE0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF,0xF,0x0,0x0,0x0,0x7,0x7
	.DB  0x0,0x0,0x0,0xF,0xF,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x38,0x18,0xF8,0xF8
	.DB  0x18,0x38,0x70,0xE0,0xC0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x31,0x33,0x37,0x36,0x36,0x3E,0x3E
	.DB  0x36,0x36,0x36,0x37,0x33,0x31,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xE0,0x70,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0x30,0x70,0xE0,0xC0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x7,0xF,0x1C,0x18,0x18,0x1C,0xF
	.DB  0x7,0x3,0x7,0xE,0x1C,0x18,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF8,0xF8,0x18,0x18,0x18,0x18,0xF8
	.DB  0xF8,0x98,0x18,0x18,0x18,0x18,0x0,0x0
_L020_INIT0:
	.DB  0xFD,0xFD,0xFD,0xFD
_L020_INIT1:
	.DB  0xEF,0x0,0xEE,0x4,0x1B,0x4,0xFE,0xFE
	.DB  0xFE,0xFE,0xEF,0x90,0x4A,0x4,0x7F,0x3F
	.DB  0xEE,0x4,0x43,0x6
_L020_INIT2:
	.DB  0xEF,0x90,0x9,0x83,0x8,0x0,0xB,0xAF
	.DB  0xA,0x0,0x5,0x0,0x6,0x0,0x7,0x0
	.DB  0xEF,0x0,0xEE,0xC,0xEF,0x90,0x0,0x80
	.DB  0xEF,0xB0,0x49,0x2,0xEF,0x0,0x7F,0x1
	.DB  0xE1,0x81,0xE2,0x2,0xE2,0x76,0xE1,0x83
_L020_INIT3:
	.DB  0x80,0x1
_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x76:
	.DB  LOW(_0x75),HIGH(_0x75),LOW(_0x75+8),HIGH(_0x75+8),LOW(_0x75+16),HIGH(_0x75+16),LOW(_0x75+24),HIGH(_0x75+24)
	.DB  LOW(_0x75+32),HIGH(_0x75+32),LOW(_0x75+40),HIGH(_0x75+40),LOW(_0x75+48),HIGH(_0x75+48),LOW(_0x75+56),HIGH(_0x75+56)
	.DB  LOW(_0x75+64),HIGH(_0x75+64),LOW(_0x75+72),HIGH(_0x75+72),LOW(_0x75+80),HIGH(_0x75+80),LOW(_0x75+88),HIGH(_0x75+88)
_0x78:
	.DB  LOW(_0x77),HIGH(_0x77),LOW(_0x77+4),HIGH(_0x77+4),LOW(_0x77+8),HIGH(_0x77+8),LOW(_0x77+12),HIGH(_0x77+12)
	.DB  LOW(_0x77+16),HIGH(_0x77+16),LOW(_0x77+20),HIGH(_0x77+20),LOW(_0x77+24),HIGH(_0x77+24)
_0x7A:
	.DB  LOW(_0x79),HIGH(_0x79),LOW(_0x79+5),HIGH(_0x79+5)
_0xFA:
	.DB  0xFF,0xFF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0
_0x0:
	.DB  0xDF,0xCD,0xC2,0xC0,0xD0,0xDF,0x20,0x0
	.DB  0xD4,0xC5,0xC2,0xD0,0xC0,0xCB,0xDF,0x0
	.DB  0xCC,0xC0,0xD0,0xD2,0xC0,0x20,0x20,0x0
	.DB  0xC0,0xCF,0xD0,0xC5,0xCB,0xDF,0x20,0x0
	.DB  0xCC,0xC0,0xDF,0x20,0x20,0x20,0x20,0x0
	.DB  0xC8,0xDE,0xCD,0xDF,0x20,0x20,0x20,0x0
	.DB  0xC8,0xDE,0xCB,0xDF,0x20,0x20,0x20,0x0
	.DB  0xC0,0xC2,0xC3,0xD3,0xD1,0xD2,0xC0,0x0
	.DB  0xD1,0xC5,0xCD,0xDF,0xC1,0xD0,0xDF,0x0
	.DB  0xCE,0xCA,0xD2,0xDF,0xC1,0xD0,0xDF,0x0
	.DB  0xCD,0xCE,0xDF,0xC1,0xD0,0xDF,0x20,0x0
	.DB  0xC4,0xC5,0xCA,0xC0,0xC1,0xD0,0xDF,0x0
	.DB  0xCF,0xCD,0x2E,0x0,0xC2,0xD2,0x2E,0x0
	.DB  0xD1,0xD0,0x2E,0x0,0xD7,0xD2,0x2E,0x0
	.DB  0xCF,0xD2,0x2E,0x0,0xD1,0xC1,0x2E,0x0
	.DB  0xC2,0xD1,0x2E,0x0,0x4D,0x45,0x4E,0x55
	.DB  0x0,0x3A,0x0,0x2D,0x0
_0x200005F:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x08
	.DW  _0x75
	.DW  _0x0*2

	.DW  0x08
	.DW  _0x75+8
	.DW  _0x0*2+8

	.DW  0x08
	.DW  _0x75+16
	.DW  _0x0*2+16

	.DW  0x08
	.DW  _0x75+24
	.DW  _0x0*2+24

	.DW  0x08
	.DW  _0x75+32
	.DW  _0x0*2+32

	.DW  0x08
	.DW  _0x75+40
	.DW  _0x0*2+40

	.DW  0x08
	.DW  _0x75+48
	.DW  _0x0*2+48

	.DW  0x08
	.DW  _0x75+56
	.DW  _0x0*2+56

	.DW  0x08
	.DW  _0x75+64
	.DW  _0x0*2+64

	.DW  0x08
	.DW  _0x75+72
	.DW  _0x0*2+72

	.DW  0x08
	.DW  _0x75+80
	.DW  _0x0*2+80

	.DW  0x08
	.DW  _0x75+88
	.DW  _0x0*2+88

	.DW  0x18
	.DW  _month
	.DW  _0x76*2

	.DW  0x04
	.DW  _0x77
	.DW  _0x0*2+96

	.DW  0x04
	.DW  _0x77+4
	.DW  _0x0*2+100

	.DW  0x04
	.DW  _0x77+8
	.DW  _0x0*2+104

	.DW  0x04
	.DW  _0x77+12
	.DW  _0x0*2+108

	.DW  0x04
	.DW  _0x77+16
	.DW  _0x0*2+112

	.DW  0x04
	.DW  _0x77+20
	.DW  _0x0*2+116

	.DW  0x04
	.DW  _0x77+24
	.DW  _0x0*2+120

	.DW  0x0E
	.DW  _week
	.DW  _0x78*2

	.DW  0x05
	.DW  _0x79
	.DW  _0x0*2+35

	.DW  0x05
	.DW  _0x79+5
	.DW  _0x0*2+124

	.DW  0x04
	.DW  _menu
	.DW  _0x7A*2

	.DW  0x02
	.DW  _0xC1
	.DW  _0x0*2+129

	.DW  0x02
	.DW  _0xE1
	.DW  _0x0*2+131

	.DW  0x02
	.DW  _0xE1+2
	.DW  _0x0*2+131

	.DW  0x02
	.DW  _0xE1+4
	.DW  _0x0*2+131

	.DW  0x0A
	.DW  0x04
	.DW  _0xFA*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x200005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 29.12.2010
;Author  : sersne
;Company : home
;Comments:
;
;
;Chip type               : ATmega64
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 1024
;*****************************************************/
;
;#include <mega64.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;#include <stdlib.h>
;#include <stdio.h>
;
;//  8x8      8x14
;
;#include "font8x8.h"
;#include <l020b_lcd.h>

	.CSEG
_HardSPI_init:
	CBI  0x18,6
	SBI  0x17,6
	SBI  0x17,2
	CBI  0x17,4
	SBI  0x18,4
	SBI  0x17,3
	SBI  0x18,0
	SBI  0x17,0
	CBI  0x18,5
	SBI  0x17,5
	CBI  0x18,4
	SBI  0x18,5
	SBI  0x17,5
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL SUBOPT_0x0
	SBI  0x18,6
	LDI  R30,LOW(45)
	LDI  R31,HIGH(45)
	CALL SUBOPT_0x0
	RET
_SPI_write:
;	SPI_Data_Byte -> Y+2
;	SPI_data_mode -> Y+1
;	CS_enable -> Y+0
	LD   R30,Y
	CPI  R30,0
	BREQ _0x1F
	SBI  0x18,0
_0x1F:
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x22
	SBI  0x18,5
	RJMP _0x25
_0x22:
	CBI  0x18,5
_0x25:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x28
	CBI  0x18,0
_0x28:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _spi
	LD   R30,Y
	CPI  R30,0
	BREQ _0x2B
	SBI  0x18,0
_0x2B:
	RJMP _0x20E0004
_lcd_wrcmd16:
;	dat -> Y+0
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	CALL SUBOPT_0x1
	LD   R30,Y
	CALL SUBOPT_0x1
	RJMP _0x20E0006
_lcd_wrdat16:
;	dat -> Y+0
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	CALL SUBOPT_0x2
	LD   R30,Y
	CALL SUBOPT_0x2
	RJMP _0x20E0006
_lcd_clear:
	ST   -Y,R17
	ST   -Y,R16
;	_General_varcls -> R16,R17
	__GETWRN 16,17,-19072
	cli
	CALL SUBOPT_0x3
	RCALL _lcd_wrcmd16
	LDI  R30,LOW(1280)
	LDI  R31,HIGH(1280)
	CALL SUBOPT_0x4
	LDI  R30,LOW(1536)
	LDI  R31,HIGH(1536)
	CALL SUBOPT_0x4
	LDI  R30,LOW(1792)
	LDI  R31,HIGH(1792)
	CALL SUBOPT_0x4
_0x2E:
	MOVW R30,R16
	__SUBWRN 16,17,1
	SBIW R30,0
	BREQ _0x30
	LDI  R30,LOW(255)
	CALL SUBOPT_0x2
	RJMP _0x2E
_0x30:
	sei
	RJMP _0x20E0007
;	ls020_fill_color -> Y+2
;	_General_varfill -> R16,R17
;	lcd_text_x -> Y+1
;	lcd_text_y -> Y+0
;	ls020x -> Y+2
;	ls020y -> Y+0
;	ls020x -> Y+4
;	ls020y -> Y+2
;	ls020color -> Y+0
;	ls020x1 -> Y+14
;	ls020y1 -> Y+12
;	ls020x2 -> Y+10
;	ls020y2 -> Y+8
;	ls020color -> Y+6
;	ls020deltax -> R16,R17
;	ls020deltay -> R18,R19
;	_General_varfillrect -> R20,R21
;	ls020color24 -> Y+0
_LS020_lcd_init:
	ST   -Y,R17
	ST   -Y,R16
;	_General_varinit -> R16,R17
	cli
	SBI  0x18,0
	SBI  0x17,0
	RCALL _HardSPI_init
	__GETWRN 16,17,0
_0x3E:
	__CPWRN 16,17,4
	BRSH _0x3F
	MOVW R30,R16
	SUBI R30,LOW(-_L020_INIT0*2)
	SBCI R31,HIGH(-_L020_INIT0*2)
	LPM  R30,Z
	CALL SUBOPT_0x1
	__ADDWRN 16,17,1
	RJMP _0x3E
_0x3F:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CALL SUBOPT_0x0
	__GETWRN 16,17,0
_0x41:
	__CPWRN 16,17,20
	BRSH _0x42
	MOVW R30,R16
	SUBI R30,LOW(-_L020_INIT1*2)
	SBCI R31,HIGH(-_L020_INIT1*2)
	LPM  R30,Z
	CALL SUBOPT_0x1
	__ADDWRN 16,17,1
	RJMP _0x41
_0x42:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CALL SUBOPT_0x0
	__GETWRN 16,17,0
_0x44:
	__CPWRN 16,17,40
	BRSH _0x45
	MOVW R30,R16
	SUBI R30,LOW(-_L020_INIT2*2)
	SBCI R31,HIGH(-_L020_INIT2*2)
	LPM  R30,Z
	CALL SUBOPT_0x1
	__ADDWRN 16,17,1
	RJMP _0x44
_0x45:
	LDI  R30,LOW(49)
	LDI  R31,HIGH(49)
	CALL SUBOPT_0x0
	__GETWRN 16,17,0
_0x47:
	__CPWRN 16,17,2
	BRSH _0x48
	MOVW R30,R16
	SUBI R30,LOW(-_L020_INIT3*2)
	SBCI R31,HIGH(-_L020_INIT3*2)
	LPM  R30,Z
	CALL SUBOPT_0x1
	__ADDWRN 16,17,1
	RJMP _0x47
_0x48:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL SUBOPT_0x0
	LDI  R30,LOW(239)
	CALL SUBOPT_0x1
	LDI  R30,LOW(144)
	CALL SUBOPT_0x1
	LDI  R30,LOW(0)
	CALL SUBOPT_0x1
	LDI  R30,LOW(0)
	CALL SUBOPT_0x1
	RCALL _lcd_clear
	LDI  R30,LOW(1)
	MOV  R13,R30
	sei
_0x20E0007:
	LD   R16,Y+
	LD   R17,Y+
	RET
_lcd_d:
;	data -> Y+0
	CALL SUBOPT_0x5
	RCALL _lcd_wrdat16
	RJMP _0x20E0006
_lcd_c:
;	command -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	CALL SUBOPT_0x4
_0x20E0006:
	ADIW R28,2
	RET
_put_char_h:
	CALL SUBOPT_0x6
;	x -> Y+10
;	y -> Y+9
;	c -> Y+8
;	color -> Y+6
;	h -> R17
;	ch -> R16
;	p -> R19
;	mask -> R18
;	tt -> R21
	CALL SUBOPT_0x7
_0x4A:
	CPI  R17,1
	BRLO _0x4B
	LDI  R21,LOW(0)
_0x4D:
	CPI  R21,1
	BRSH _0x4E
	CALL SUBOPT_0x8
	LDI  R26,LOW(24)
	LDI  R27,HIGH(24)
	CALL SUBOPT_0x9
_0x50:
	CPI  R19,8
	BRSH _0x51
	MOV  R30,R18
	AND  R30,R16
	BREQ _0x52
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP _0xEA
_0x52:
	ST   -Y,R5
	ST   -Y,R4
_0xEA:
	RCALL _lcd_d
	LSL  R18
	SUBI R19,-1
	RJMP _0x50
_0x51:
	SUBI R21,-1
	RJMP _0x4D
_0x4E:
	SUBI R17,1
	RJMP _0x4A
_0x4B:
	RJMP _0x20E0005
_put_char_l:
	CALL SUBOPT_0x6
;	x -> Y+10
;	y -> Y+9
;	c -> Y+8
;	color -> Y+6
;	h -> R17
;	ch -> R16
;	p -> R19
;	mask -> R18
;	tt -> R21
	CALL SUBOPT_0x7
_0x55:
	CPI  R17,1
	BRLO _0x56
	LDI  R21,LOW(0)
_0x58:
	CPI  R21,1
	BRSH _0x59
	CALL SUBOPT_0x8
	LDI  R26,LOW(48)
	LDI  R27,HIGH(48)
	CALL SUBOPT_0x9
_0x5B:
	CPI  R19,8
	BRSH _0x5C
	MOV  R30,R18
	AND  R30,R16
	BREQ _0x5D
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP _0xEB
_0x5D:
	ST   -Y,R5
	ST   -Y,R4
_0xEB:
	RCALL _lcd_d
	LSL  R18
	SUBI R19,-1
	RJMP _0x5B
_0x5C:
	SUBI R21,-1
	RJMP _0x58
_0x59:
	SUBI R17,1
	RJMP _0x55
_0x56:
_0x20E0005:
	CALL __LOADLOCR6
	ADIW R28,11
	RET
;	x -> Y+10
;	y -> Y+9
;	c -> Y+8
;	color -> Y+6
;	h -> R17
;	ch -> R16
;	p -> R19
;	mask -> R18
;	tt -> R21
_put_string:
	ST   -Y,R17
	ST   -Y,R16
;	x -> Y+7
;	y -> Y+6
;	*str -> Y+4
;	color -> Y+2
;	j -> R17
;	y_plus -> R16
	LDI  R17,0
	LDI  R16,LOW(0)
_0x6A:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R26,R17
	LDI  R27,0
	CP   R26,R30
	CPC  R27,R31
	BRSH _0x6C
	MOV  R30,R17
	LSL  R30
	LSL  R30
	LSL  R30
	LDD  R26,Y+7
	CALL SUBOPT_0xA
	RCALL _put_char_h
	LDD  R26,Y+7
	SUBI R26,-LOW(8)
	MOV  R30,R17
	LSL  R30
	LSL  R30
	LSL  R30
	CALL SUBOPT_0xA
	RCALL _put_char_l
	SUBI R17,-1
	SUBI R16,-LOW(8)
	RJMP _0x6A
_0x6C:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,8
	RET
;
;#include <io.h>
;#include <math.h>
;
;
;// 1 Wire Bus functions
;#asm
   .equ __w1_port=0x18
   .equ __w1_bit=7
; 0000 002B #endasm
;
;#include <1wire.h>
;
;// DS1820 temperature sensor functions
;#include <ds1820.h>
;#include <delay.h>
;// Declare your global variables here
;
;#define UP PINC.0
;#define LEFT PINC.2
;#define RIGHT PINC.1
;#define DOWN PINC.4
;#define MENU PINC.3
;
;// SPI functions
;#include <spi.h>
;
;unsigned char sec;
;
;unsigned char show_data;
;
;int T,X1,X2,X3;
;
;unsigned char focus;
;
;
;//dat[0] - ten hours
;//dat[1] - one hours
;//dat[2] - ten minutes
;//dat[3] - one minutes
;//dat[4] - week
;//dat[5] - ten day
;//dat[6] - one day
;//dat[7] - month
;//dat[8] - ten year
;//dat[9] - one year
;unsigned char dat[10];
;
;
;unsigned char time;
;unsigned char seconds;
;
;//unsigned int fillcolor;
;//char buffer[24];
;//unsigned int i;
;
;unsigned char *month[12] =
;{
;" ",
;"",
;"  ",
;" ",
;"    ",
;"   ",
;"   ",
;"",
;"",
;"",
;" ",
;""
;};

	.DSEG
_0x75:
	.BYTE 0x60
;
;
;unsigned char *week[7] =
;{
;{"."},
;{"."},
;{"."},
;{"."},
;{"."},
;{"."},
;{"."}
;};
_0x77:
	.BYTE 0x1C
;
;unsigned char *menu[2] =
;{
;"    ",
;"MENU"
;};
_0x79:
	.BYTE 0xA
;
;
;// Declare your global variables here
;
;void set_month(char a, char b, char c, char d)
; 0000 0080 {

	.CSEG
_set_month:
; 0000 0081 
; 0000 0082         if ((a == c) && (b == d))
;	a -> Y+3
;	b -> Y+2
;	c -> Y+1
;	d -> Y+0
	LDD  R30,Y+1
	LDD  R26,Y+3
	CP   R30,R26
	BRNE _0x7C
	LD   R30,Y
	LDD  R26,Y+2
	CP   R30,R26
	BREQ _0x7D
_0x7C:
	RJMP _0x7B
_0x7D:
; 0000 0083         {
; 0000 0084            dat[5] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,5
; 0000 0085            dat[6] = 1;
	LDI  R30,LOW(1)
	__PUTB1MN _dat,6
; 0000 0086 
; 0000 0087            dat[7] = dat[7] + 1; // 
	__GETB1MN _dat,7
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,7
; 0000 0088         }
; 0000 0089 }
_0x7B:
	ADIW R28,4
	RET
;
;
;void set_h_day(char a, char b, char c)
; 0000 008D {
_set_h_day:
; 0000 008E 
; 0000 008F         if (dat[7] == a)  // 
;	a -> Y+2
;	b -> Y+1
;	c -> Y+0
	__GETB2MN _dat,7
	LDD  R30,Y+2
	CP   R30,R26
	BRNE _0x7E
; 0000 0090         {
; 0000 0091                 if ((++dat[5] > b)&&(dat[6] > c))
	__GETB1MN _dat,5
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,5
	MOV  R26,R30
	LDD  R30,Y+1
	CP   R30,R26
	BRSH _0x80
	__GETB2MN _dat,6
	LD   R30,Y
	CP   R30,R26
	BRLO _0x81
_0x80:
	RJMP _0x7F
_0x81:
; 0000 0092                 {
; 0000 0093                         dat[5] = b;
	LDD  R30,Y+1
	__PUTB1MN _dat,5
; 0000 0094                         dat[6] = c;
	LD   R30,Y
	__PUTB1MN _dat,6
; 0000 0095                 }
; 0000 0096                 else
	RJMP _0x82
_0x7F:
; 0000 0097                 {
; 0000 0098                         if (dat[5] > b) dat[5] = b;
	__GETB2MN _dat,5
	LDD  R30,Y+1
	CP   R30,R26
	BRSH _0x83
	__PUTB1MN _dat,5
; 0000 0099                 }
_0x83:
_0x82:
; 0000 009A         }
; 0000 009B 
; 0000 009C 
; 0000 009D 
; 0000 009E }
_0x7E:
	RJMP _0x20E0004
;
;
;void set_l_day(char a, char b, char c)
; 0000 00A2 {
_set_l_day:
; 0000 00A3 
; 0000 00A4         if (dat[7] == a)  // 
;	a -> Y+2
;	b -> Y+1
;	c -> Y+0
	__GETB2MN _dat,7
	LDD  R30,Y+2
	CP   R30,R26
	BRNE _0x84
; 0000 00A5         {
; 0000 00A6                 dat[6] = dat[6] + 1;
	__GETB1MN _dat,6
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,6
; 0000 00A7                 if ((dat[5] > b)&&(dat[6] > c))
	__GETB2MN _dat,5
	LDD  R30,Y+1
	CP   R30,R26
	BRSH _0x86
	__GETB2MN _dat,6
	LD   R30,Y
	CP   R30,R26
	BRLO _0x87
_0x86:
	RJMP _0x85
_0x87:
; 0000 00A8                 {
; 0000 00A9                         dat[5] = b;
	LDD  R30,Y+1
	__PUTB1MN _dat,5
; 0000 00AA                         dat[6] = c;
	LD   R30,Y
	RJMP _0xED
; 0000 00AB                 }
; 0000 00AC                 else
_0x85:
; 0000 00AD                 {
; 0000 00AE                         if ((dat[6] > 9)&&(dat[5] < b)) dat[6] = 9;
	__GETB2MN _dat,6
	CPI  R26,LOW(0xA)
	BRLO _0x8A
	__GETB2MN _dat,5
	LDD  R30,Y+1
	CP   R26,R30
	BRLO _0x8B
_0x8A:
	RJMP _0x89
_0x8B:
	LDI  R30,LOW(9)
_0xED:
	__PUTB1MN _dat,6
; 0000 00AF                 }
_0x89:
; 0000 00B0         }
; 0000 00B1 
; 0000 00B2 
; 0000 00B3 
; 0000 00B4 }
_0x84:
_0x20E0004:
	ADIW R28,3
	RET
;
;/*
;==============================================================================================
;           Timer 0
;==============================================================================================
;*/
;
;interrupt [TIM0_OVF] void timer0_ovf_isr (void)
; 0000 00BD {
_timer0_ovf_isr:
	CALL SUBOPT_0xB
; 0000 00BE TCNT0=0x64;
	LDI  R30,LOW(100)
	OUT  0x32,R30
; 0000 00BF 
; 0000 00C0         if (++time == 150)
	LDS  R26,_time
	SUBI R26,-LOW(1)
	STS  _time,R26
	CPI  R26,LOW(0x96)
	BREQ PC+3
	JMP _0x8C
; 0000 00C1         {
; 0000 00C2           time = 0;
	LDI  R30,LOW(0)
	STS  _time,R30
; 0000 00C3 
; 0000 00C4                 if (MENU == 0)
	SBIC 0x13,3
	RJMP _0x8D
; 0000 00C5                 {
; 0000 00C6                         if (show_data == 0)
	LDS  R30,_show_data
	CPI  R30,0
	BRNE _0x8E
; 0000 00C7                         {
; 0000 00C8                                 show_data = 1;
	LDI  R30,LOW(1)
	CALL SUBOPT_0xC
; 0000 00C9                                 put_string(0,72,menu[0],BLACK);
	LDS  R30,_menu
	LDS  R31,_menu+1
	RJMP _0xEE
; 0000 00CA                         }
; 0000 00CB                         else
_0x8E:
; 0000 00CC                         {
; 0000 00CD                                 show_data = 0;
	LDI  R30,LOW(0)
	CALL SUBOPT_0xC
; 0000 00CE                                 put_string(0,72,menu[1],BLACK);
	__GETW1MN _menu,2
_0xEE:
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xD
	RCALL _put_string
; 0000 00CF                         }
; 0000 00D0                 }
; 0000 00D1 
; 0000 00D2 
; 0000 00D3 
; 0000 00D4                 if (show_data == 0)
_0x8D:
	LDS  R30,_show_data
	CPI  R30,0
	BREQ PC+3
	JMP _0x90
; 0000 00D5                 {
; 0000 00D6 
; 0000 00D7 
; 0000 00D8 
; 0000 00D9 
; 0000 00DA                 //dat[0] - ten hours
; 0000 00DB                 //dat[1] - one hours
; 0000 00DC                 //dat[2] - ten minutes
; 0000 00DD                 //dat[3] - one minutes
; 0000 00DE                 //dat[4] - week
; 0000 00DF                 //dat[5] - ten day
; 0000 00E0                 //dat[6] - one day
; 0000 00E1                 //dat[7] - month
; 0000 00E2                 //dat[8] - ten year
; 0000 00E3                 //dat[9] - one year
; 0000 00E4 
; 0000 00E5 
; 0000 00E6 
; 0000 00E7                         if (LEFT == 0)
	SBIC 0x13,2
	RJMP _0x91
; 0000 00E8                         {
; 0000 00E9                                 focus = focus + 1;
	LDS  R30,_focus
	SUBI R30,-LOW(1)
	STS  _focus,R30
; 0000 00EA                                 if (focus >= 8) focus = 7;
	LDS  R26,_focus
	CPI  R26,LOW(0x8)
	BRLO _0x92
	LDI  R30,LOW(7)
	STS  _focus,R30
; 0000 00EB                         }
_0x92:
; 0000 00EC 
; 0000 00ED                         if (RIGHT == 0)
_0x91:
	SBIC 0x13,1
	RJMP _0x93
; 0000 00EE                         {
; 0000 00EF                                 focus = focus - 1;
	LDS  R30,_focus
	LDI  R31,0
	SBIW R30,1
	STS  _focus,R30
; 0000 00F0                                 if (focus == 0xFF) focus = 0;
	LDS  R26,_focus
	CPI  R26,LOW(0xFF)
	BRNE _0x94
	LDI  R30,LOW(0)
	STS  _focus,R30
; 0000 00F1                         }
_0x94:
; 0000 00F2 
; 0000 00F3                         if (UP == 0)
_0x93:
	SBIC 0x13,0
	RJMP _0x95
; 0000 00F4                         {
; 0000 00F5                                 if (focus == 0) if (++dat[0] == 3) dat[0] = 2;
	LDS  R30,_focus
	CPI  R30,0
	BRNE _0x96
	LDS  R26,_dat
	SUBI R26,-LOW(1)
	STS  _dat,R26
	CPI  R26,LOW(0x3)
	BRNE _0x97
	LDI  R30,LOW(2)
	STS  _dat,R30
; 0000 00F6 
; 0000 00F7                                 if (focus == 1)
_0x97:
_0x96:
	LDS  R26,_focus
	CPI  R26,LOW(0x1)
	BRNE _0x98
; 0000 00F8                                 {
; 0000 00F9                                         if (++dat[1] == 10) dat[1] = 9;
	__GETB1MN _dat,1
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,1
	CPI  R30,LOW(0xA)
	BRNE _0x99
	LDI  R30,LOW(9)
	__PUTB1MN _dat,1
; 0000 00FA 
; 0000 00FB                                         if (dat[0] >= 2)
_0x99:
	LDS  R26,_dat
	CPI  R26,LOW(0x2)
	BRLO _0x9A
; 0000 00FC                                         {
; 0000 00FD                                              if (dat[1] > 3) dat[1] = 3;
	__GETB2MN _dat,1
	CPI  R26,LOW(0x4)
	BRLO _0x9B
	LDI  R30,LOW(3)
	__PUTB1MN _dat,1
; 0000 00FE                                         }
_0x9B:
; 0000 00FF                                 }
_0x9A:
; 0000 0100 
; 0000 0101 
; 0000 0102                                 if (focus == 2) if (++dat[2] >= 6) dat[2] = 5;
_0x98:
	LDS  R26,_focus
	CPI  R26,LOW(0x2)
	BRNE _0x9C
	__GETB1MN _dat,2
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,2
	CPI  R30,LOW(0x6)
	BRLO _0x9D
	LDI  R30,LOW(5)
	__PUTB1MN _dat,2
; 0000 0103 
; 0000 0104                                 if (focus == 3) if (++dat[3] == 10) dat[3] = 9;
_0x9D:
_0x9C:
	LDS  R26,_focus
	CPI  R26,LOW(0x3)
	BRNE _0x9E
	__GETB1MN _dat,3
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,3
	CPI  R30,LOW(0xA)
	BRNE _0x9F
	LDI  R30,LOW(9)
	__PUTB1MN _dat,3
; 0000 0105 
; 0000 0106 
; 0000 0107                                 if (focus == 4) if (++dat[4] >= 8) dat[4] = 7;
_0x9F:
_0x9E:
	LDS  R26,_focus
	CPI  R26,LOW(0x4)
	BRNE _0xA0
	__GETB1MN _dat,4
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,4
	CPI  R30,LOW(0x8)
	BRLO _0xA1
	LDI  R30,LOW(7)
	__PUTB1MN _dat,4
; 0000 0108 
; 0000 0109 
; 0000 010A                                 if (focus == 5) if (++dat[7] >= 12) dat[7] = 11;
_0xA1:
_0xA0:
	LDS  R26,_focus
	CPI  R26,LOW(0x5)
	BRNE _0xA2
	__GETB1MN _dat,7
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,7
	CPI  R30,LOW(0xC)
	BRLO _0xA3
	LDI  R30,LOW(11)
	__PUTB1MN _dat,7
; 0000 010B 
; 0000 010C                                 if (focus == 6)
_0xA3:
_0xA2:
	LDS  R26,_focus
	CPI  R26,LOW(0x6)
	BRNE _0xA4
; 0000 010D                                 {
; 0000 010E 
; 0000 010F                                         set_h_day(0,3,1);  //  
	CALL SUBOPT_0xE
	RCALL _set_h_day
; 0000 0110                                         set_h_day(1,2,8);  //  
	CALL SUBOPT_0xF
	RCALL _set_h_day
; 0000 0111                                         set_h_day(2,3,1);  //  
	CALL SUBOPT_0x10
	RCALL _set_h_day
; 0000 0112                                         set_h_day(3,3,0);  //  
	CALL SUBOPT_0x11
	RCALL _set_h_day
; 0000 0113                                         set_h_day(4,3,1);  //  
	CALL SUBOPT_0x12
	RCALL _set_h_day
; 0000 0114                                         set_h_day(5,3,0);  //  
	CALL SUBOPT_0x13
	RCALL _set_h_day
; 0000 0115                                         set_h_day(6,3,1);  //  
	CALL SUBOPT_0x14
	RCALL _set_h_day
; 0000 0116                                         set_h_day(7,3,1);  //  
	CALL SUBOPT_0x15
	RCALL _set_h_day
; 0000 0117                                         set_h_day(8,3,0);  //  
	CALL SUBOPT_0x16
	RCALL _set_h_day
; 0000 0118                                         set_h_day(9,3,1);  //  
	CALL SUBOPT_0x17
	RCALL _set_h_day
; 0000 0119                                         set_h_day(10,3,0);  //  
	CALL SUBOPT_0x18
	RCALL _set_h_day
; 0000 011A                                         set_h_day(11,3,1);  //  
	CALL SUBOPT_0x19
	RCALL _set_h_day
; 0000 011B 
; 0000 011C                                 }
; 0000 011D 
; 0000 011E 
; 0000 011F                                 if (focus == 7)
_0xA4:
	LDS  R26,_focus
	CPI  R26,LOW(0x7)
	BRNE _0xA5
; 0000 0120                                 {
; 0000 0121 
; 0000 0122                                         set_l_day(0,3,1);  //  
	CALL SUBOPT_0xE
	RCALL _set_l_day
; 0000 0123                                         set_l_day(1,2,8);  //  
	CALL SUBOPT_0xF
	RCALL _set_l_day
; 0000 0124                                         set_l_day(2,3,1);  //  
	CALL SUBOPT_0x10
	RCALL _set_l_day
; 0000 0125                                         set_l_day(3,3,0);  //  
	CALL SUBOPT_0x11
	RCALL _set_l_day
; 0000 0126                                         set_l_day(4,3,1);  //  
	CALL SUBOPT_0x12
	RCALL _set_l_day
; 0000 0127                                         set_l_day(5,3,0);  //  
	CALL SUBOPT_0x13
	RCALL _set_l_day
; 0000 0128                                         set_l_day(6,3,1);  //  
	CALL SUBOPT_0x14
	RCALL _set_l_day
; 0000 0129                                         set_l_day(7,3,1);  //  
	CALL SUBOPT_0x15
	RCALL _set_l_day
; 0000 012A                                         set_l_day(8,3,0);  //  
	CALL SUBOPT_0x16
	RCALL _set_l_day
; 0000 012B                                         set_l_day(9,3,1);  //  
	CALL SUBOPT_0x17
	RCALL _set_l_day
; 0000 012C                                         set_l_day(10,3,0);  //  
	CALL SUBOPT_0x18
	RCALL _set_l_day
; 0000 012D                                         set_l_day(11,3,1);  //  
	CALL SUBOPT_0x19
	RCALL _set_l_day
; 0000 012E 
; 0000 012F                                 }
; 0000 0130 
; 0000 0131 
; 0000 0132                                 if (focus == 8)
_0xA5:
	LDS  R26,_focus
	CPI  R26,LOW(0x8)
	BRNE _0xA6
; 0000 0133                                 {
; 0000 0134                                         if (++dat[9] > 9)
	__GETB1MN _dat,9
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,9
	CPI  R30,LOW(0xA)
	BRLO _0xA7
; 0000 0135                                         {
; 0000 0136                                                 dat[9] = 0;
	CALL SUBOPT_0x1A
; 0000 0137 
; 0000 0138                                                 if (++dat[8] > 2) dat[8] = 2;
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,8
	CPI  R30,LOW(0x3)
	BRLO _0xA8
	LDI  R30,LOW(2)
	__PUTB1MN _dat,8
; 0000 0139 
; 0000 013A 
; 0000 013B                                         }
_0xA8:
; 0000 013C                                 }
_0xA7:
; 0000 013D                         }
_0xA6:
; 0000 013E 
; 0000 013F 
; 0000 0140 
; 0000 0141 
; 0000 0142 
; 0000 0143 
; 0000 0144                         if (DOWN == 0)
_0x95:
	SBIC 0x13,4
	RJMP _0xA9
; 0000 0145                         {
; 0000 0146                                 if (focus == 0) if (--dat[0] == 0xFF) dat[0] = 0;
	LDS  R30,_focus
	CPI  R30,0
	BRNE _0xAA
	LDS  R26,_dat
	SUBI R26,LOW(1)
	STS  _dat,R26
	CPI  R26,LOW(0xFF)
	BRNE _0xAB
	LDI  R30,LOW(0)
	STS  _dat,R30
; 0000 0147 
; 0000 0148                                 if (focus == 1) if (--dat[1] == 0xFF) dat[1] = 0;
_0xAB:
_0xAA:
	LDS  R26,_focus
	CPI  R26,LOW(0x1)
	BRNE _0xAC
	__GETB1MN _dat,1
	SUBI R30,LOW(1)
	__PUTB1MN _dat,1
	CPI  R30,LOW(0xFF)
	BRNE _0xAD
	LDI  R30,LOW(0)
	__PUTB1MN _dat,1
; 0000 0149 
; 0000 014A                                 if (focus == 2) if (--dat[2] == 0xFF) dat[2] = 0;
_0xAD:
_0xAC:
	LDS  R26,_focus
	CPI  R26,LOW(0x2)
	BRNE _0xAE
	__GETB1MN _dat,2
	SUBI R30,LOW(1)
	__PUTB1MN _dat,2
	CPI  R30,LOW(0xFF)
	BRNE _0xAF
	LDI  R30,LOW(0)
	__PUTB1MN _dat,2
; 0000 014B 
; 0000 014C                                 if (focus == 3) if (--dat[3] == 0xFF) dat[3] = 0;
_0xAF:
_0xAE:
	LDS  R26,_focus
	CPI  R26,LOW(0x3)
	BRNE _0xB0
	__GETB1MN _dat,3
	SUBI R30,LOW(1)
	__PUTB1MN _dat,3
	CPI  R30,LOW(0xFF)
	BRNE _0xB1
	LDI  R30,LOW(0)
	__PUTB1MN _dat,3
; 0000 014D 
; 0000 014E                                 if (focus == 4) if (--dat[4] == 0xFF) dat[4] = 0;
_0xB1:
_0xB0:
	LDS  R26,_focus
	CPI  R26,LOW(0x4)
	BRNE _0xB2
	__GETB1MN _dat,4
	SUBI R30,LOW(1)
	__PUTB1MN _dat,4
	CPI  R30,LOW(0xFF)
	BRNE _0xB3
	LDI  R30,LOW(0)
	__PUTB1MN _dat,4
; 0000 014F 
; 0000 0150                                 if (focus == 5) if (--dat[7] == 0xFF) dat[7] = 0;
_0xB3:
_0xB2:
	LDS  R26,_focus
	CPI  R26,LOW(0x5)
	BRNE _0xB4
	__GETB1MN _dat,7
	SUBI R30,LOW(1)
	__PUTB1MN _dat,7
	CPI  R30,LOW(0xFF)
	BRNE _0xB5
	LDI  R30,LOW(0)
	__PUTB1MN _dat,7
; 0000 0151 
; 0000 0152                                 if (focus == 6) if (--dat[5] == 0xFF) dat[5] = 0;
_0xB5:
_0xB4:
	LDS  R26,_focus
	CPI  R26,LOW(0x6)
	BRNE _0xB6
	__GETB1MN _dat,5
	SUBI R30,LOW(1)
	__PUTB1MN _dat,5
	CPI  R30,LOW(0xFF)
	BRNE _0xB7
	LDI  R30,LOW(0)
	__PUTB1MN _dat,5
; 0000 0153 
; 0000 0154                                 if (focus == 7) if (--dat[6] == 0xFF) dat[6] = 0;
_0xB7:
_0xB6:
	LDS  R26,_focus
	CPI  R26,LOW(0x7)
	BRNE _0xB8
	__GETB1MN _dat,6
	SUBI R30,LOW(1)
	__PUTB1MN _dat,6
	CPI  R30,LOW(0xFF)
	BRNE _0xB9
	LDI  R30,LOW(0)
	__PUTB1MN _dat,6
; 0000 0155 
; 0000 0156                                 if (focus == 8)
_0xB9:
_0xB8:
	LDS  R26,_focus
	CPI  R26,LOW(0x8)
	BRNE _0xBA
; 0000 0157                                 {
; 0000 0158                                         if (--dat[9] == 0xFF)
	__GETB1MN _dat,9
	SUBI R30,LOW(1)
	__PUTB1MN _dat,9
	CPI  R30,LOW(0xFF)
	BRNE _0xBB
; 0000 0159                                         {
; 0000 015A                                                 dat[9] = 0;
	CALL SUBOPT_0x1A
; 0000 015B 
; 0000 015C                                                 if (--dat[8] == 0xFF) dat[8] = 0;
	SUBI R30,LOW(1)
	__PUTB1MN _dat,8
	CPI  R30,LOW(0xFF)
	BRNE _0xBC
	LDI  R30,LOW(0)
	__PUTB1MN _dat,8
; 0000 015D                                         }
_0xBC:
; 0000 015E                                 }
_0xBB:
; 0000 015F                         }
_0xBA:
; 0000 0160 
; 0000 0161 
; 0000 0162 
; 0000 0163 
; 0000 0164                         if (focus == 0)
_0xA9:
	LDS  R30,_focus
	CPI  R30,0
	BRNE _0xBD
; 0000 0165                         {
; 0000 0166 
; 0000 0167                                 put_char_h(0,0,dat[0],RED);
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1C
; 0000 0168                                 put_char_l(8,0,dat[0],RED);
	CALL SUBOPT_0x1D
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	RJMP _0xEF
; 0000 0169 
; 0000 016A                         }
; 0000 016B                         else
_0xBD:
; 0000 016C                         {
; 0000 016D 
; 0000 016E                                 put_char_h(0,0,dat[0],BLACK);
	CALL SUBOPT_0x1B
	CALL SUBOPT_0xD
	RCALL _put_char_h
; 0000 016F                                 put_char_l(8,0,dat[0],BLACK);
	CALL SUBOPT_0x1D
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0xEF:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _put_char_l
; 0000 0170 
; 0000 0171                         }
; 0000 0172 
; 0000 0173                         if (focus == 1)
	LDS  R26,_focus
	CPI  R26,LOW(0x1)
	BRNE _0xBF
; 0000 0174                         {
; 0000 0175 
; 0000 0176                                 put_char_h(16,0,dat[1],RED);
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x1C
; 0000 0177                                 put_char_l(24,0,dat[1],RED);
	CALL SUBOPT_0x1F
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	RJMP _0xF0
; 0000 0178                         }
; 0000 0179                         else
_0xBF:
; 0000 017A                         {
; 0000 017B 
; 0000 017C                                 put_char_h(16,0,dat[1],BLACK);
	CALL SUBOPT_0x1E
	CALL SUBOPT_0xD
	RCALL _put_char_h
; 0000 017D                                 put_char_l(24,0,dat[1],BLACK);
	CALL SUBOPT_0x1F
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0xF0:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _put_char_l
; 0000 017E 
; 0000 017F 
; 0000 0180 
; 0000 0181                         }
; 0000 0182 
; 0000 0183 
; 0000 0184 
; 0000 0185                         put_string(32,5,":",BLACK);
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	__POINTW1MN _0xC1,0
	CALL SUBOPT_0x20
	RCALL _put_string
; 0000 0186 
; 0000 0187 
; 0000 0188 
; 0000 0189                         if (focus == 2)
	LDS  R26,_focus
	CPI  R26,LOW(0x2)
	BRNE _0xC2
; 0000 018A                         {
; 0000 018B                                 put_char_h(48,0,dat[2],RED);
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1C
; 0000 018C                                 put_char_l(56,0,dat[2],RED);
	CALL SUBOPT_0x22
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	RJMP _0xF1
; 0000 018D                         }
; 0000 018E                         else
_0xC2:
; 0000 018F                         {
; 0000 0190                                 put_char_h(48,0,dat[2],BLACK);
	CALL SUBOPT_0x21
	CALL SUBOPT_0xD
	RCALL _put_char_h
; 0000 0191                                 put_char_l(56,0,dat[2],BLACK);
	CALL SUBOPT_0x22
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0xF1:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _put_char_l
; 0000 0192                         }
; 0000 0193 
; 0000 0194                         if (focus == 3)
	LDS  R26,_focus
	CPI  R26,LOW(0x3)
	BRNE _0xC4
; 0000 0195                         {
; 0000 0196                                 put_char_h(64,0,dat[3],RED);
	CALL SUBOPT_0x23
	CALL SUBOPT_0x1C
; 0000 0197                                 put_char_l(72,0,dat[3],RED);
	CALL SUBOPT_0x24
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	RJMP _0xF2
; 0000 0198                         }
; 0000 0199                         else
_0xC4:
; 0000 019A                         {
; 0000 019B                                 put_char_h(64,0,dat[3],BLACK);
	CALL SUBOPT_0x23
	CALL SUBOPT_0xD
	RCALL _put_char_h
; 0000 019C                                 put_char_l(72,0,dat[3],BLACK);
	CALL SUBOPT_0x24
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0xF2:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _put_char_l
; 0000 019D 
; 0000 019E                         }
; 0000 019F 
; 0000 01A0 
; 0000 01A1                         if (focus == 4)
	LDS  R26,_focus
	CPI  R26,LOW(0x4)
	BRNE _0xC6
; 0000 01A2                         {
; 0000 01A3                                 put_string(92,0,week[dat[4]],RED);
	CALL SUBOPT_0x25
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	RJMP _0xF3
; 0000 01A4                         }
; 0000 01A5                         else
_0xC6:
; 0000 01A6                         {
; 0000 01A7                                 put_string(92,0,week[dat[4]],BLACK);
	CALL SUBOPT_0x25
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0xF3:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _put_string
; 0000 01A8                         }
; 0000 01A9 
; 0000 01AA                         if (focus == 6)
	LDS  R26,_focus
	CPI  R26,LOW(0x6)
	BRNE _0xC8
; 0000 01AB                         {
; 0000 01AC                                 put_char_h(0,30,dat[5] + 48,RED);
	CALL SUBOPT_0x26
	CALL SUBOPT_0x1C
; 0000 01AD                                 put_char_l(8,30,dat[5] + 48,RED);
	CALL SUBOPT_0x27
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	RJMP _0xF4
; 0000 01AE                         }
; 0000 01AF                         else
_0xC8:
; 0000 01B0                         {
; 0000 01B1                                 put_char_h(0,30,dat[5] + 48,BLACK);
	CALL SUBOPT_0x26
	CALL SUBOPT_0xD
	RCALL _put_char_h
; 0000 01B2                                 put_char_l(8,30,dat[5] + 48,BLACK);
	CALL SUBOPT_0x27
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0xF4:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _put_char_l
; 0000 01B3                         }
; 0000 01B4 
; 0000 01B5                         if (focus == 7)
	LDS  R26,_focus
	CPI  R26,LOW(0x7)
	BRNE _0xCA
; 0000 01B6                         {
; 0000 01B7                                 put_char_h(16,30,dat[6] + 48,RED);
	CALL SUBOPT_0x28
	CALL SUBOPT_0x1C
; 0000 01B8                                 put_char_l(24,30,dat[6] + 48,RED);
	CALL SUBOPT_0x29
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	RJMP _0xF5
; 0000 01B9                         }
; 0000 01BA                         else
_0xCA:
; 0000 01BB                         {
; 0000 01BC                                 put_char_h(16,30,dat[6] + 48,BLACK);
	CALL SUBOPT_0x28
	CALL SUBOPT_0xD
	RCALL _put_char_h
; 0000 01BD                                 put_char_l(24,30,dat[6] + 48,BLACK);
	CALL SUBOPT_0x29
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0xF5:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _put_char_l
; 0000 01BE                         }
; 0000 01BF 
; 0000 01C0 
; 0000 01C1                         if (focus == 5)
	LDS  R26,_focus
	CPI  R26,LOW(0x5)
	BRNE _0xCC
; 0000 01C2                         {
; 0000 01C3                                 put_string(40,30,month[dat[7]],RED);
	CALL SUBOPT_0x2A
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	RJMP _0xF6
; 0000 01C4                         }
; 0000 01C5                         else
_0xCC:
; 0000 01C6                         {
; 0000 01C7                                 put_string(40,30,month[dat[7]],BLACK);
	CALL SUBOPT_0x2A
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0xF6:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _put_string
; 0000 01C8                         }
; 0000 01C9 
; 0000 01CA 
; 0000 01CB                 }
; 0000 01CC         }
_0x90:
; 0000 01CD }
_0x8C:
	RJMP _0xF9

	.DSEG
_0xC1:
	.BYTE 0x2
;
;
;
;
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 01D3 {

	.CSEG
_timer1_ovf_isr:
	CALL SUBOPT_0xB
; 0000 01D4 
; 0000 01D5 
; 0000 01D6         TCNT1H=0xC2;
	LDI  R30,LOW(194)
	OUT  0x2D,R30
; 0000 01D7         TCNT1L=0xF7;
	LDI  R30,LOW(247)
	OUT  0x2C,R30
; 0000 01D8 
; 0000 01D9 
; 0000 01DA 
; 0000 01DB 
; 0000 01DC         sec++;
	INC  R12
; 0000 01DD         if (sec >= 60)
	LDI  R30,LOW(60)
	CP   R12,R30
	BRSH PC+3
	JMP _0xCE
; 0000 01DE         {
; 0000 01DF         sec = 0;
	CLR  R12
; 0000 01E0 
; 0000 01E1            dat[3] = dat[3]+1;
	__GETB1MN _dat,3
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,3
; 0000 01E2            if (dat[3] >= 10)
	__GETB2MN _dat,3
	CPI  R26,LOW(0xA)
	BRSH PC+3
	JMP _0xCF
; 0000 01E3            {
; 0000 01E4                 dat[3] = 0; //  10  -> 0
	LDI  R30,LOW(0)
	__PUTB1MN _dat,3
; 0000 01E5                 dat[2] = dat[2] + 1;
	__GETB1MN _dat,2
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,2
; 0000 01E6 
; 0000 01E7                 if (dat[2] >= 6)
	__GETB2MN _dat,2
	CPI  R26,LOW(0x6)
	BRSH PC+3
	JMP _0xD0
; 0000 01E8                 {
; 0000 01E9                    dat[2] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,2
; 0000 01EA                    dat[1] = dat[1] + 1;
	__GETB1MN _dat,1
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,1
; 0000 01EB 
; 0000 01EC                    if (dat[1] >= 10)
	__GETB2MN _dat,1
	CPI  R26,LOW(0xA)
	BRLO _0xD1
; 0000 01ED                    {
; 0000 01EE                      dat[1] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,1
; 0000 01EF                      dat[0] = dat[0] + 1;
	LDS  R30,_dat
	SUBI R30,-LOW(1)
	STS  _dat,R30
; 0000 01F0                    }
; 0000 01F1 
; 0000 01F2                    if (dat[0] >= 2)
_0xD1:
	LDS  R26,_dat
	CPI  R26,LOW(0x2)
	BRSH PC+3
	JMP _0xD2
; 0000 01F3                    {
; 0000 01F4 
; 0000 01F5                      if (dat[1] >= 4)
	__GETB2MN _dat,1
	CPI  R26,LOW(0x4)
	BRSH PC+3
	JMP _0xD3
; 0000 01F6                      //    (24 )
; 0000 01F7                      {
; 0000 01F8                          dat[1] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,1
; 0000 01F9                          dat[0] = 0;
	STS  _dat,R30
; 0000 01FA                          dat[4] = dat[4] + 1;
	__GETB1MN _dat,4
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,4
; 0000 01FB 
; 0000 01FC                          if (dat[4] >= 7)  // 
	__GETB2MN _dat,4
	CPI  R26,LOW(0x7)
	BRLO _0xD4
; 0000 01FD                          {
; 0000 01FE                             dat[4] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,4
; 0000 01FF                          }
; 0000 0200 
; 0000 0201                          dat[6] = dat[6] + 1;
_0xD4:
	__GETB1MN _dat,6
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,6
; 0000 0202                          if (dat[6] >= 10)
	__GETB2MN _dat,6
	CPI  R26,LOW(0xA)
	BRLO _0xD5
; 0000 0203                          //  10 
; 0000 0204                          {
; 0000 0205                             dat[6] = 0;           //  
	LDI  R30,LOW(0)
	__PUTB1MN _dat,6
; 0000 0206                             dat[5] = dat[5] + 1;  //  
	__GETB1MN _dat,5
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,5
; 0000 0207                          }
; 0000 0208 
; 0000 0209                          //   
; 0000 020A                          set_month(3,1,dat[5],dat[6]); //  
_0xD5:
	CALL SUBOPT_0x2B
; 0000 020B                          set_month(2,8,dat[5],dat[6]); //  
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(8)
	CALL SUBOPT_0x2C
; 0000 020C                          set_month(3,1,dat[5],dat[6]); //  
; 0000 020D                          set_month(3,0,dat[5],dat[6]); //  
	CALL SUBOPT_0x2D
; 0000 020E                          set_month(3,1,dat[5],dat[6]); //  
; 0000 020F                          set_month(3,0,dat[5],dat[6]); //  
	CALL SUBOPT_0x2D
; 0000 0210                          set_month(3,1,dat[5],dat[6]); //  
; 0000 0211                          set_month(3,1,dat[5],dat[6]); //  
	CALL SUBOPT_0x2B
; 0000 0212                          set_month(3,0,dat[5],dat[6]); //  
	CALL SUBOPT_0x2D
; 0000 0213                          set_month(3,1,dat[5],dat[6]); //  
; 0000 0214                          set_month(3,0,dat[5],dat[6]); //  
	CALL SUBOPT_0x2D
; 0000 0215                          set_month(3,1,dat[5],dat[6]); //  
; 0000 0216 
; 0000 0217 
; 0000 0218                          if (dat[7] >= 12)  // 12 
	__GETB2MN _dat,7
	CPI  R26,LOW(0xC)
	BRLO _0xD6
; 0000 0219                          {
; 0000 021A                              dat[7] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,7
; 0000 021B 
; 0000 021C                              dat[9] = dat[9] + 1;
	__GETB1MN _dat,9
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,9
; 0000 021D                              if (dat[9] >= 10)
	__GETB2MN _dat,9
	CPI  R26,LOW(0xA)
	BRLO _0xD7
; 0000 021E                              {
; 0000 021F                                 dat[9] = 0;
	CALL SUBOPT_0x1A
; 0000 0220                                 dat[8] = dat[8] + 1;
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,8
; 0000 0221 
; 0000 0222                                 if (dat[8] == 10) dat[8] = 0;
	__GETB2MN _dat,8
	CPI  R26,LOW(0xA)
	BRNE _0xD8
	LDI  R30,LOW(0)
	__PUTB1MN _dat,8
; 0000 0223                              }
_0xD8:
; 0000 0224                          }
_0xD7:
; 0000 0225                      }
_0xD6:
; 0000 0226                    }
_0xD3:
; 0000 0227                 }
_0xD2:
; 0000 0228            }
_0xD0:
; 0000 0229         }
_0xCF:
; 0000 022A 
; 0000 022B 
; 0000 022C 
; 0000 022D 
; 0000 022E         if (show_data == 1)
_0xCE:
	LDS  R26,_show_data
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xD9
; 0000 022F         {
; 0000 0230 
; 0000 0231 
; 0000 0232             switch (++seconds)
	LDS  R30,_seconds
	SUBI R30,-LOW(1)
	STS  _seconds,R30
; 0000 0233             {
; 0000 0234                 case 5: seconds = 0;
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0xDC
	LDI  R30,LOW(0)
	STS  _seconds,R30
; 0000 0235 
; 0000 0236 
; 0000 0237 
; 0000 0238                      T =  ds1820_temperature_10(0)/10;     // read DS1820 every 5 sec.
	CALL SUBOPT_0xD
	CALL _ds1820_temperature_10
	MOVW R26,R30
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x2F
; 0000 0239 
; 0000 023A 
; 0000 023B 
; 0000 023C                      // 
; 0000 023D                      X3=X2;
	LDS  R30,_X2
	LDS  R31,_X2+1
	STS  _X3,R30
	STS  _X3+1,R31
; 0000 023E                      X2=T;
	CALL SUBOPT_0x30
	STS  _X2,R30
	STS  _X2+1,R31
; 0000 023F                      if (X2==X3)
	LDS  R30,_X3
	LDS  R31,_X3+1
	LDS  R26,_X2
	LDS  R27,_X2+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0xDE
; 0000 0240                      {
; 0000 0241 
; 0000 0242                            X1=T;
	CALL SUBOPT_0x30
	STS  _X1,R30
	STS  _X1+1,R31
; 0000 0243                      }
; 0000 0244 
; 0000 0245                      T=(X1);
_0xDE:
	LDS  R30,_X1
	LDS  R31,_X1+1
	CALL SUBOPT_0x2F
; 0000 0246 
; 0000 0247                      put_char_h(48, 72, 31,BLACK);
	LDI  R30,LOW(48)
	CALL SUBOPT_0x31
	RCALL _put_char_h
; 0000 0248                      put_char_l(56, 72, 31,BLACK);
	LDI  R30,LOW(56)
	CALL SUBOPT_0x31
	RCALL _put_char_l
; 0000 0249 
; 0000 024A                      if(T<0)
	LDS  R26,_T+1
	TST  R26
	BRPL _0xDF
; 0000 024B                      {
; 0000 024C 
; 0000 024D 
; 0000 024E                             // lcd_chr(60, 50, 3); //  
; 0000 024F 
; 0000 0250                              T = abs(T);   // get only amplitude
	CALL SUBOPT_0x32
; 0000 0251 
; 0000 0252                              put_char_h(32, 72,(T%10)+48,BLACK);
	CALL SUBOPT_0x33
; 0000 0253                              put_char_l(40, 72,(T%10)+48,BLACK);
	CALL SUBOPT_0x34
; 0000 0254 
; 0000 0255 
; 0000 0256                              if ((T/10) == 0)
	SBIW R30,0
	BRNE _0xE0
; 0000 0257                              {
; 0000 0258 
; 0000 0259                                      put_string(0,72,"-",BLACK);  // put -
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	__POINTW1MN _0xE1,0
	CALL SUBOPT_0x20
	CALL SUBOPT_0x35
; 0000 025A 
; 0000 025B                                      put_char_h(16,72,32,BLACK);
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0xD
	CALL SUBOPT_0x36
; 0000 025C                                      put_char_l(24,72,32,BLACK);
	LDI  R30,LOW(32)
	RJMP _0xF7
; 0000 025D 
; 0000 025E                              }
; 0000 025F                              else
_0xE0:
; 0000 0260                              {
; 0000 0261 
; 0000 0262                                      put_string(0,72,"-",BLACK);    // put -
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	__POINTW1MN _0xE1,2
	CALL SUBOPT_0x20
	CALL SUBOPT_0x35
; 0000 0263 
; 0000 0264                                      put_char_h(16,72,(T/10)+48,BLACK);
	CALL SUBOPT_0x37
	CALL SUBOPT_0x38
	CALL SUBOPT_0x36
; 0000 0265                                      put_char_l(24,72,(T/10)+48,BLACK);
	CALL SUBOPT_0x37
	SUBI R30,-LOW(48)
_0xF7:
	ST   -Y,R30
	CALL SUBOPT_0xD
	RCALL _put_char_l
; 0000 0266                              }
; 0000 0267 
; 0000 0268                      }
; 0000 0269                      else
	RJMP _0xE3
_0xDF:
; 0000 026A                      {
; 0000 026B 
; 0000 026C 
; 0000 026D                              T = abs(T);   // get only amplitude
	CALL SUBOPT_0x32
; 0000 026E 
; 0000 026F                              put_char_h(32, 72,(T%10)+48,BLACK);
	CALL SUBOPT_0x33
; 0000 0270                              put_char_l(40, 72,(T%10)+48,BLACK);
	CALL SUBOPT_0x34
; 0000 0271 
; 0000 0272                              if ((T/10) == 0)
	SBIW R30,0
	BRNE _0xE4
; 0000 0273                              {
; 0000 0274                                      put_char_h(16,72,32,BLACK);
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0xD
	CALL SUBOPT_0x36
; 0000 0275                                      put_char_l(24,72,32,BLACK);
	LDI  R30,LOW(32)
	RJMP _0xF8
; 0000 0276                              }
; 0000 0277                              else
_0xE4:
; 0000 0278                              {
; 0000 0279                                      put_char_h(16,72,(T/10)+48,BLACK);
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	CALL SUBOPT_0x37
	CALL SUBOPT_0x38
	CALL SUBOPT_0x36
; 0000 027A                                      put_char_l(24,72,(T/10)+48,BLACK);
	CALL SUBOPT_0x37
	SUBI R30,-LOW(48)
_0xF8:
	ST   -Y,R30
	CALL SUBOPT_0xD
	RCALL _put_char_l
; 0000 027B                              }
; 0000 027C 
; 0000 027D 
; 0000 027E                      }
_0xE3:
; 0000 027F 
; 0000 0280 
; 0000 0281             }
_0xDC:
; 0000 0282 
; 0000 0283 
; 0000 0284 
; 0000 0285 
; 0000 0286                 //dat[0] - ten hours
; 0000 0287                 //dat[1] - one hours
; 0000 0288                 //dat[2] - ten minutes
; 0000 0289                 //dat[3] - one minutes
; 0000 028A                 //dat[4] - week
; 0000 028B                 //dat[5] - ten day
; 0000 028C                 //dat[6] - one day
; 0000 028D                 //dat[7] - month
; 0000 028E                 //dat[8] - ten year
; 0000 028F                 //dat[9] - one year
; 0000 0290 
; 0000 0291 
; 0000 0292                 put_char_h(0,0,dat[0] + 48,BLACK);
	LDI  R30,LOW(0)
	CALL SUBOPT_0x39
	RCALL _put_char_h
; 0000 0293                 put_char_l(8,0,dat[0] + 48,BLACK);
	LDI  R30,LOW(8)
	CALL SUBOPT_0x39
	RCALL _put_char_l
; 0000 0294 
; 0000 0295 
; 0000 0296                 put_char_h(16,0,dat[1] + 48,BLACK);
	LDI  R30,LOW(16)
	CALL SUBOPT_0x3A
	RCALL _put_char_h
; 0000 0297                 put_char_l(24,0,dat[1] + 48,BLACK);
	LDI  R30,LOW(24)
	CALL SUBOPT_0x3A
	RCALL _put_char_l
; 0000 0298 
; 0000 0299 
; 0000 029A                 put_string(32,0,":",BLACK);
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__POINTW1MN _0xE1,4
	CALL SUBOPT_0x20
	RCALL _put_string
; 0000 029B 
; 0000 029C 
; 0000 029D 
; 0000 029E                 put_char_h(48,0,dat[2] + 48,BLACK);
	LDI  R30,LOW(48)
	CALL SUBOPT_0x3B
	RCALL _put_char_h
; 0000 029F                 put_char_l(56,0,dat[2] + 48,BLACK);
	LDI  R30,LOW(56)
	CALL SUBOPT_0x3B
	RCALL _put_char_l
; 0000 02A0 
; 0000 02A1 
; 0000 02A2                 put_char_h(64,0,dat[3] + 48,BLACK);
	LDI  R30,LOW(64)
	CALL SUBOPT_0x3C
	RCALL _put_char_h
; 0000 02A3                 put_char_l(72,0,dat[3] + 48,BLACK);
	LDI  R30,LOW(72)
	CALL SUBOPT_0x3C
	RCALL _put_char_l
; 0000 02A4 
; 0000 02A5 
; 0000 02A6                 put_string(92,0,week[dat[4]],BLACK);
	LDI  R30,LOW(92)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,4
	LDI  R26,LOW(_week)
	LDI  R27,HIGH(_week)
	CALL SUBOPT_0x3D
	RCALL _put_string
; 0000 02A7 
; 0000 02A8 
; 0000 02A9 
; 0000 02AA 
; 0000 02AB                 put_char_h(0,30,dat[5] + 48,BLACK);
	CALL SUBOPT_0x26
	CALL SUBOPT_0xD
	RCALL _put_char_h
; 0000 02AC                 put_char_l(8,30,dat[5] + 48,BLACK);
	CALL SUBOPT_0x27
	CALL SUBOPT_0xD
	RCALL _put_char_l
; 0000 02AD 
; 0000 02AE 
; 0000 02AF                 put_char_h(16,30,dat[6] + 48,BLACK);
	CALL SUBOPT_0x28
	CALL SUBOPT_0xD
	RCALL _put_char_h
; 0000 02B0                 put_char_l(24,30,dat[6] + 48,BLACK);
	CALL SUBOPT_0x29
	CALL SUBOPT_0xD
	RCALL _put_char_l
; 0000 02B1 
; 0000 02B2 
; 0000 02B3                 put_string(40,30,month[dat[7]],BLACK);
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	__GETB1MN _dat,7
	LDI  R26,LOW(_month)
	LDI  R27,HIGH(_month)
	CALL SUBOPT_0x3D
	RCALL _put_string
; 0000 02B4 
; 0000 02B5 
; 0000 02B6 /*
; 0000 02B7                 put_char(82,20,50,BLACK);
; 0000 02B8 
; 0000 02B9                 put_char(91,20,48,BLACK);
; 0000 02BA 
; 0000 02BB                 put_char(100,20,dat[8] + 48,BLACK);
; 0000 02BC 
; 0000 02BD                 put_char(109,20,dat[9] + 48,BLACK);
; 0000 02BE 
; 0000 02BF */
; 0000 02C0         }
; 0000 02C1 
; 0000 02C2 
; 0000 02C3 }
_0xD9:
_0xF9:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI

	.DSEG
_0xE1:
	.BYTE 0x6
;
;
;
;void main(void)
; 0000 02C8 {

	.CSEG
_main:
; 0000 02C9 // Declare your local variables here
; 0000 02CA 
; 0000 02CB 
; 0000 02CC 
; 0000 02CD 
; 0000 02CE 
; 0000 02CF // Input/Output Ports initialization
; 0000 02D0 // Port A initialization
; 0000 02D1 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 02D2 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 02D3 PORTA=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1B,R30
; 0000 02D4 DDRA=0xFF;
	OUT  0x1A,R30
; 0000 02D5 
; 0000 02D6 // Port B initialization
; 0000 02D7 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 02D8 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 02D9 PORTB=0xFF;
	OUT  0x18,R30
; 0000 02DA DDRB=0xFF;
	OUT  0x17,R30
; 0000 02DB 
; 0000 02DC // Port C initialization
; 0000 02DD // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 02DE // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 02DF PORTC=0xFF;
	OUT  0x15,R30
; 0000 02E0 DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0000 02E1 
; 0000 02E2 // Port D initialization
; 0000 02E3 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 02E4 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 02E5 PORTD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x12,R30
; 0000 02E6 DDRD=0xFF;
	OUT  0x11,R30
; 0000 02E7 
; 0000 02E8 // Port E initialization
; 0000 02E9 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 02EA // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 02EB PORTE=0xFF;
	OUT  0x3,R30
; 0000 02EC DDRE=0xFF;
	OUT  0x2,R30
; 0000 02ED 
; 0000 02EE // Port F initialization
; 0000 02EF // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 02F0 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 02F1 PORTF=0xFF;
	STS  98,R30
; 0000 02F2 DDRF=0xFF;
	STS  97,R30
; 0000 02F3 
; 0000 02F4 // Port G initialization
; 0000 02F5 // Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 02F6 // State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 02F7 PORTG=0x1F;
	LDI  R30,LOW(31)
	STS  101,R30
; 0000 02F8 DDRG=0x1F;
	STS  100,R30
; 0000 02F9 
; 0000 02FA //  Timer 0
; 0000 02FB //TCCR0=0x00;
; 0000 02FC TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 02FD TCNT0=0x64;
	LDI  R30,LOW(100)
	OUT  0x32,R30
; 0000 02FE 
; 0000 02FF //  Timer 1
; 0000 0300 TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
; 0000 0301 TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 0302 TCNT1H=0xC2;
	LDI  R30,LOW(194)
	OUT  0x2D,R30
; 0000 0303 TCNT1L=0xF7;
	LDI  R30,LOW(247)
	OUT  0x2C,R30
; 0000 0304 OCR1BL=0x00;
	LDI  R30,LOW(0)
	OUT  0x28,R30
; 0000 0305 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0306 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0307 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0308 
; 0000 0309 // Timer/Counter 2 initialization
; 0000 030A // Clock source: System Clock
; 0000 030B // Clock value: Timer2 Stopped
; 0000 030C // Mode: Normal top=FFh
; 0000 030D // OC2 output: Disconnected
; 0000 030E TCCR2=0x00;
	OUT  0x25,R30
; 0000 030F TCNT2=0x00;
	OUT  0x24,R30
; 0000 0310 OCR2=0x00;
	OUT  0x23,R30
; 0000 0311 
; 0000 0312 // Timer/Counter 3 initialization
; 0000 0313 // Clock source: System Clock
; 0000 0314 // Clock value: Timer3 Stopped
; 0000 0315 // Mode: Normal top=FFFFh
; 0000 0316 // OC3A output: Discon.
; 0000 0317 // OC3B output: Discon.
; 0000 0318 // OC3C output: Discon.
; 0000 0319 // Noise Canceler: Off
; 0000 031A // Input Capture on Falling Edge
; 0000 031B // Timer3 Overflow Interrupt: Off
; 0000 031C // Input Capture Interrupt: Off
; 0000 031D // Compare A Match Interrupt: Off
; 0000 031E // Compare B Match Interrupt: Off
; 0000 031F // Compare C Match Interrupt: Off
; 0000 0320 TCCR3A=0x00;
	STS  139,R30
; 0000 0321 TCCR3B=0x00;
	STS  138,R30
; 0000 0322 TCNT3H=0x00;
	STS  137,R30
; 0000 0323 TCNT3L=0x00;
	STS  136,R30
; 0000 0324 ICR3H=0x00;
	STS  129,R30
; 0000 0325 ICR3L=0x00;
	STS  128,R30
; 0000 0326 OCR3AH=0x00;
	STS  135,R30
; 0000 0327 OCR3AL=0x00;
	STS  134,R30
; 0000 0328 OCR3BH=0x00;
	STS  133,R30
; 0000 0329 OCR3BL=0x00;
	STS  132,R30
; 0000 032A OCR3CH=0x00;
	STS  131,R30
; 0000 032B OCR3CL=0x00;
	STS  130,R30
; 0000 032C 
; 0000 032D // External Interrupt(s) initialization
; 0000 032E // INT0: Off
; 0000 032F // INT1: Off
; 0000 0330 // INT2: Off
; 0000 0331 // INT3: Off
; 0000 0332 // INT4: Off
; 0000 0333 // INT5: Off
; 0000 0334 // INT6: Off
; 0000 0335 // INT7: Off
; 0000 0336 EICRA=0x00;
	STS  106,R30
; 0000 0337 EICRB=0x00;
	OUT  0x3A,R30
; 0000 0338 EIMSK=0x00;
	OUT  0x39,R30
; 0000 0339 
; 0000 033A // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 033B TIMSK = 0b101;
	LDI  R30,LOW(5)
	OUT  0x37,R30
; 0000 033C //TIMSK = 0b00000000;
; 0000 033D ETIMSK=0x00;
	LDI  R30,LOW(0)
	STS  125,R30
; 0000 033E 
; 0000 033F // Analog Comparator initialization
; 0000 0340 // Analog Comparator: Off
; 0000 0341 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0342 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0343 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 0344 
; 0000 0345 
; 0000 0346 
; 0000 0347 
; 0000 0348 // spi
; 0000 0349 SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
; 0000 034A SPSR=0x01;
	LDI  R30,LOW(1)
	OUT  0xE,R30
; 0000 034B 
; 0000 034C 
; 0000 034D 
; 0000 034E 
; 0000 034F         //dat[0] - ten hours
; 0000 0350         //dat[1] - one hours
; 0000 0351         //dat[2] - ten minutes
; 0000 0352         //dat[3] - one minutes
; 0000 0353         //dat[4] - week
; 0000 0354         //dat[5] - ten day
; 0000 0355         //dat[6] - one day
; 0000 0356         //dat[7] - month
; 0000 0357         //dat[8] - ten year
; 0000 0358         //dat[9] - one year
; 0000 0359           dat[0] = 0;
	LDI  R30,LOW(0)
	STS  _dat,R30
; 0000 035A           dat[1] = 0;
	__PUTB1MN _dat,1
; 0000 035B           dat[2] = 0;
	__PUTB1MN _dat,2
; 0000 035C           dat[3] = 0;
	__PUTB1MN _dat,3
; 0000 035D           dat[4] = 1;
	LDI  R30,LOW(1)
	__PUTB1MN _dat,4
; 0000 035E           dat[5] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,5
; 0000 035F           dat[6] = 7;
	LDI  R30,LOW(7)
	__PUTB1MN _dat,6
; 0000 0360           dat[7] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,7
; 0000 0361           dat[8] = 1;
	LDI  R30,LOW(1)
	__PUTB1MN _dat,8
; 0000 0362           dat[9] = 1;
	__PUTB1MN _dat,9
; 0000 0363 
; 0000 0364 
; 0000 0365 
; 0000 0366 
; 0000 0367       X1=0;
	LDI  R30,LOW(0)
	STS  _X1,R30
	STS  _X1+1,R30
; 0000 0368       X2=0;
	STS  _X2,R30
	STS  _X2+1,R30
; 0000 0369       X3=0;
	STS  _X3,R30
	STS  _X3+1,R30
; 0000 036A       T = 0;
	STS  _T,R30
	STS  _T+1,R30
; 0000 036B 
; 0000 036C seconds = 0;
	STS  _seconds,R30
; 0000 036D 
; 0000 036E focus = 0;
	STS  _focus,R30
; 0000 036F 
; 0000 0370 show_data = 1;
	LDI  R30,LOW(1)
	STS  _show_data,R30
; 0000 0371 
; 0000 0372 time = 0;
	LDI  R30,LOW(0)
	STS  _time,R30
; 0000 0373 
; 0000 0374 // 1 Wire Bus initialization
; 0000 0375    w1_init();
	CALL _w1_init
; 0000 0376 
; 0000 0377 
; 0000 0378 #asm("sei")
	sei
; 0000 0379 
; 0000 037A 
; 0000 037B LS020_lcd_init();
	CALL _LS020_lcd_init
; 0000 037C 
; 0000 037D 
; 0000 037E while (1)
_0xE6:
; 0000 037F {
; 0000 0380 
; 0000 0381 }
	RJMP _0xE6
; 0000 0382 }
_0xE9:
	RJMP _0xE9

	.CSEG
_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret

	.DSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_spi:
	LD   R30,Y
	OUT  0xF,R30
_0x2060003:
	SBIS 0xE,7
	RJMP _0x2060003
	IN   R30,0xF
	ADIW R28,1
	RET

	.CSEG

	.CSEG
_ds1820_select:
	ST   -Y,R17
	CALL _w1_init
	CPI  R30,0
	BRNE _0x20A0003
	LDI  R30,LOW(0)
	RJMP _0x20E0003
_0x20A0003:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	SBIW R30,0
	BREQ _0x20A0004
	LDI  R30,LOW(85)
	ST   -Y,R30
	CALL _w1_write
	LDI  R17,LOW(0)
_0x20A0006:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	ST   -Y,R30
	CALL _w1_write
	SUBI R17,-LOW(1)
	CPI  R17,8
	BRLO _0x20A0006
	RJMP _0x20A0008
_0x20A0004:
	LDI  R30,LOW(204)
	ST   -Y,R30
	CALL _w1_write
_0x20A0008:
	LDI  R30,LOW(1)
_0x20E0003:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_ds1820_read_spd:
	CALL __SAVELOCR4
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ds1820_select
	CPI  R30,0
	BRNE _0x20A0009
	LDI  R30,LOW(0)
	RJMP _0x20E0002
_0x20A0009:
	LDI  R30,LOW(190)
	ST   -Y,R30
	CALL _w1_write
	LDI  R17,LOW(0)
	__POINTWRM 18,19,___ds1820_scratch_pad
_0x20A000B:
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	CALL _w1_read
	POP  R26
	POP  R27
	ST   X,R30
	SUBI R17,-LOW(1)
	CPI  R17,9
	BRLO _0x20A000B
	LDI  R30,LOW(___ds1820_scratch_pad)
	LDI  R31,HIGH(___ds1820_scratch_pad)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	CALL _w1_dow_crc8
	CALL __LNEGB1
_0x20E0002:
	CALL __LOADLOCR4
	ADIW R28,6
	RET
_ds1820_temperature_10:
	CALL SUBOPT_0x5
	RCALL _ds1820_select
	CPI  R30,0
	BRNE _0x20A000D
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	RJMP _0x20E0001
_0x20A000D:
	LDI  R30,LOW(68)
	ST   -Y,R30
	CALL _w1_write
	LDI  R30,LOW(550)
	LDI  R31,HIGH(550)
	CALL SUBOPT_0x0
	CALL SUBOPT_0x5
	RCALL _ds1820_read_spd
	CPI  R30,0
	BRNE _0x20A000E
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	RJMP _0x20E0001
_0x20A000E:
	CALL _w1_init
	__GETB1HMN ___ds1820_scratch_pad,1
	LDI  R30,LOW(0)
	MOVW R26,R30
	LDS  R30,___ds1820_scratch_pad
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12
_0x20E0001:
	ADIW R28,2
	RET

	.CSEG

	.DSEG
___ds1820_scratch_pad:
	.BYTE 0x9
_show_data:
	.BYTE 0x1
_T:
	.BYTE 0x2
_X1:
	.BYTE 0x2
_X2:
	.BYTE 0x2
_X3:
	.BYTE 0x2
_focus:
	.BYTE 0x1
_dat:
	.BYTE 0xA
_time:
	.BYTE 0x1
_seconds:
	.BYTE 0x1
_month:
	.BYTE 0x18
_week:
	.BYTE 0xE
_menu:
	.BYTE 0x4
__seed_G100:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x0:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:42 WORDS
SUBOPT_0x1:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _SPI_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _SPI_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(61328)
	LDI  R31,HIGH(61328)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_wrcmd16

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x6:
	CALL __SAVELOCR6
	LDD  R30,Y+10
	LDI  R31,0
	LDI  R26,LOW(152)
	LDI  R27,HIGH(152)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	SUBI R30,-LOW(16)
	STD  Y+10,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:46 WORDS
SUBOPT_0x7:
	CALL _lcd_c
	LDI  R30,LOW(1284)
	LDI  R31,HIGH(1284)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_c
	LDD  R30,Y+9
	LDI  R31,0
	SUBI R30,LOW(-2048)
	SBCI R31,HIGH(-2048)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_c
	LDD  R30,Y+10
	LDI  R31,0
	SUBI R30,LOW(-2560)
	SBCI R31,HIGH(-2560)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_c
	LDD  R30,Y+9
	LDI  R31,0
	SUBI R30,LOW(-2328)
	SBCI R31,HIGH(-2328)
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_c
	LDD  R30,Y+10
	LDI  R31,0
	SUBI R30,LOW(-2824)
	SBCI R31,HIGH(-2824)
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_c
	LDI  R17,LOW(24)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x8:
	LDD  R30,Y+8
	LDI  R31,0
	SBIW R30,31
	LDI  R26,LOW(48)
	LDI  R27,HIGH(48)
	CALL __MULW12U
	SUBI R30,LOW(-_ascii_tab*2)
	SBCI R31,HIGH(-_ascii_tab*2)
	MOVW R22,R30
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x9:
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	ADD  R30,R22
	ADC  R31,R23
	LPM  R16,Z
	LDI  R18,LOW(1)
	LDI  R19,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xA:
	ADD  R30,R26
	ADD  R30,R16
	ST   -Y,R30
	LDD  R30,Y+7
	ST   -Y,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	ST   -Y,R30
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xB:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	STS  _show_data,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 38 TIMES, CODE SIZE REDUCTION:71 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(3)
	ST   -Y,R30
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(0)
	__PUTB1MN _dat,9
	__GETB1MN _dat,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	LDS  R30,_dat
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x1C:
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _put_char_h

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1D:
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,_dat
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,1
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1F:
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,1
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x20:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x21:
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x23:
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,3
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x24:
	LDI  R30,LOW(72)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,3
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x25:
	LDI  R30,LOW(92)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,4
	LDI  R26,LOW(_week)
	LDI  R27,HIGH(_week)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x26:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	__GETB1MN _dat,5
	SUBI R30,-LOW(48)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x27:
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	__GETB1MN _dat,5
	SUBI R30,-LOW(48)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x28:
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	__GETB1MN _dat,6
	SUBI R30,-LOW(48)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x29:
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	__GETB1MN _dat,6
	SUBI R30,-LOW(48)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x2A:
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	__GETB1MN _dat,7
	LDI  R26,LOW(_month)
	LDI  R27,HIGH(_month)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:57 WORDS
SUBOPT_0x2B:
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	JMP  _set_month

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x2C:
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
	RJMP SUBOPT_0x2B

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2D:
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP SUBOPT_0x2C

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2E:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2F:
	STS  _T,R30
	STS  _T+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x30:
	LDS  R30,_T
	LDS  R31,_T+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x31:
	ST   -Y,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	LDI  R30,LOW(31)
	ST   -Y,R30
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x32:
	RCALL SUBOPT_0x30
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	RCALL SUBOPT_0x2F
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	LDS  R26,_T
	LDS  R27,_T+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	SUBI R30,-LOW(48)
	ST   -Y,R30
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x33:
	CALL _put_char_h
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	LDS  R26,_T
	LDS  R27,_T+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	SUBI R30,-LOW(48)
	ST   -Y,R30
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x34:
	CALL _put_char_l
	LDS  R26,_T
	LDS  R27,_T+1
	RJMP SUBOPT_0x2E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x35:
	CALL _put_string
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x36:
	CALL _put_char_h
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x37:
	LDS  R26,_T
	LDS  R27,_T+1
	RJMP SUBOPT_0x2E

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x38:
	SUBI R30,-LOW(48)
	ST   -Y,R30
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x39:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,_dat
	RJMP SUBOPT_0x38

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3A:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,1
	RJMP SUBOPT_0x38

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3B:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,2
	RJMP SUBOPT_0x38

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3C:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,3
	RJMP SUBOPT_0x38

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3D:
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RJMP SUBOPT_0x20


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x780
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x4B
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USW 0x130
	sbis __w1_port-2,__w1_bit
	inc  r30
	__DELAY_USW 0x618
	ret

__w1_read_bit:
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xB
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x3B
	clc
	sbic __w1_port-2,__w1_bit
	sec
	ror  r30
	__DELAY_USW 0x140
	ret

__w1_write_bit:
	clt
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xB
	sbrc r23,0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x45
	sbic __w1_port-2,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USW 0x12C
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x1B
	set
	ret

_w1_read:
	ldi  r22,8
	__w1_read0:
	rcall __w1_read_bit
	dec  r22
	brne __w1_read0
	ret

_w1_write:
	ldi  r22,8
	ld   r23,y+
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

_w1_dow_crc8:
	clr  r30
	ld   r24,y
	tst  r24
	breq __w1_dow_crc83
	ldi  r22,0x18
	ldd  r26,y+1
	ldd  r27,y+2
__w1_dow_crc80:
	ldi  r25,8
	ld   r31,x+
__w1_dow_crc81:
	mov  r23,r31
	eor  r23,r30
	ror  r23
	brcc __w1_dow_crc82
	eor  r30,r22
__w1_dow_crc82:
	ror  r30
	lsr  r31
	dec  r25
	brne __w1_dow_crc81
	dec  r24
	brne __w1_dow_crc80
__w1_dow_crc83:
	adiw r28,3
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
